/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.checker.logic;

import java.util.Set;

import fr.supelec.adlv.checker.PortInstance;

public abstract class UnaryExpr extends Expr {
	protected final Expr expr;

	protected UnaryExpr(Expr expr) {
		this.expr = expr;
	}

	public Expr getExpr() {
		return expr;
	}

	/**
	 * Creates a new instance of the (concrete, final) class.
	 * @param a
	 * @return
	 */
	public abstract UnaryExpr create(Expr a);

	@Override
	public Set<PortInstance> getInputSignals() {
		return expr.getInputSignals();
	}
}
