/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.adlv.AdlvFactory
 * @model kind="package"
 * @generated
 */
public interface AdlvPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "adlv";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///fr/supelec/adlv.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "fr.supelec.adlv";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	AdlvPackage eINSTANCE = fr.supelec.adlv.impl.AdlvPackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ApplicationImpl <em>Application</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ApplicationImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getApplication()
	 * @generated
	 */
	int APPLICATION = 0;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__NAME = 0;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__PORTS = 1;

	/**
	 * The feature id for the '<em><b>Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__MODULE = 2;

	/**
	 * The feature id for the '<em><b>Initial Steps</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__INITIAL_STEPS = 3;

	/**
	 * The feature id for the '<em><b>Output Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__OUTPUT_CONNECTION = 4;

	/**
	 * The feature id for the '<em><b>Input Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__INPUT_CONNECTION = 5;

	/**
	 * The feature id for the '<em><b>Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__COMPONENTS = 6;

	/**
	 * The feature id for the '<em><b>Safety Clause</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__SAFETY_CLAUSE = 7;

	/**
	 * The feature id for the '<em><b>Static Configuration</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION__STATIC_CONFIGURATION = 8;

	/**
	 * The number of structural features of the '<em>Application</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int APPLICATION_FEATURE_COUNT = 9;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.PortImpl <em>Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.PortImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getPort()
	 * @generated
	 */
	int PORT = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Token Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__TOKEN_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Component</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__COMPONENT = 2;

	/**
	 * The feature id for the '<em><b>Connection To</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__CONNECTION_TO = 3;

	/**
	 * The feature id for the '<em><b>Connection From</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__CONNECTION_FROM = 4;

	/**
	 * The feature id for the '<em><b>Consumer Port Expression</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__CONSUMER_PORT_EXPRESSION = 5;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT__APPLICATION = 6;

	/**
	 * The number of structural features of the '<em>Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.TokenTypeImpl <em>Token Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.TokenTypeImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getTokenType()
	 * @generated
	 */
	int TOKEN_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOKEN_TYPE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOKEN_TYPE__MODULE = 1;

	/**
	 * The feature id for the '<em><b>Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOKEN_TYPE__PORT = 2;

	/**
	 * The number of structural features of the '<em>Token Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOKEN_TYPE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ModuleImpl <em>Module</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ModuleImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getModule()
	 * @generated
	 */
	int MODULE = 3;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Application</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE__APPLICATION = 1;

	/**
	 * The feature id for the '<em><b>Component Types</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE__COMPONENT_TYPES = 2;

	/**
	 * The feature id for the '<em><b>Token Types</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE__TOKEN_TYPES = 3;

	/**
	 * The number of structural features of the '<em>Module</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODULE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ComponentTypeImpl <em>Component Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ComponentTypeImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getComponentType()
	 * @generated
	 */
	int COMPONENT_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Tool</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__TOOL = 1;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__PORTS = 2;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__COMPONENT = 3;

	/**
	 * The feature id for the '<em><b>Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE__MODULE = 4;

	/**
	 * The number of structural features of the '<em>Component Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_TYPE_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ComponentImpl <em>Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ComponentImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getComponent()
	 * @generated
	 */
	int COMPONENT = 5;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__NAME = 0;

	/**
	 * The feature id for the '<em><b>Component Configuration Step</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__COMPONENT_CONFIGURATION_STEP = 1;

	/**
	 * The feature id for the '<em><b>Input Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__INPUT_CONNECTION = 2;

	/**
	 * The feature id for the '<em><b>Output Connection</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__OUTPUT_CONNECTION = 3;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__APPLICATION = 4;

	/**
	 * The feature id for the '<em><b>Consumer Port Expression</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__CONSUMER_PORT_EXPRESSION = 5;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__TYPE = 6;

	/**
	 * The number of structural features of the '<em>Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ConfigurationStepImpl <em>Configuration Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ConfigurationStepImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getConfigurationStep()
	 * @generated
	 */
	int CONFIGURATION_STEP = 7;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONFIGURATION_STEP__APPLICATION = 0;

	/**
	 * The feature id for the '<em><b>State Transition</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONFIGURATION_STEP__STATE_TRANSITION = 1;

	/**
	 * The number of structural features of the '<em>Configuration Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONFIGURATION_STEP_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ComponentConfigurationStepImpl <em>Component Configuration Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ComponentConfigurationStepImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getComponentConfigurationStep()
	 * @generated
	 */
	int COMPONENT_CONFIGURATION_STEP = 6;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CONFIGURATION_STEP__APPLICATION = CONFIGURATION_STEP__APPLICATION;

	/**
	 * The feature id for the '<em><b>State Transition</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CONFIGURATION_STEP__STATE_TRANSITION = CONFIGURATION_STEP__STATE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CONFIGURATION_STEP__COMPONENT = CONFIGURATION_STEP_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Component Configuration Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_CONFIGURATION_STEP_FEATURE_COUNT = CONFIGURATION_STEP_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ConsumerPortImpl <em>Consumer Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ConsumerPortImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getConsumerPort()
	 * @generated
	 */
	int CONSUMER_PORT = 8;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__NAME = PORT__NAME;

	/**
	 * The feature id for the '<em><b>Token Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__TOKEN_TYPE = PORT__TOKEN_TYPE;

	/**
	 * The feature id for the '<em><b>Component</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__COMPONENT = PORT__COMPONENT;

	/**
	 * The feature id for the '<em><b>Connection To</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__CONNECTION_TO = PORT__CONNECTION_TO;

	/**
	 * The feature id for the '<em><b>Connection From</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__CONNECTION_FROM = PORT__CONNECTION_FROM;

	/**
	 * The feature id for the '<em><b>Consumer Port Expression</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__CONSUMER_PORT_EXPRESSION = PORT__CONSUMER_PORT_EXPRESSION;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__APPLICATION = PORT__APPLICATION;

	/**
	 * The feature id for the '<em><b>Set Expression</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__SET_EXPRESSION = PORT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Set Attribute</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__SET_ATTRIBUTE = PORT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Steps</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT__STEPS = PORT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Consumer Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSUMER_PORT_FEATURE_COUNT = PORT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ExpressionImpl <em>Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ExpressionImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getExpression()
	 * @generated
	 */
	int EXPRESSION = 9;

	/**
	 * The feature id for the '<em><b>Producer Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION__PRODUCER_PORT = 0;

	/**
	 * The feature id for the '<em><b>Unary Expression</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION__UNARY_EXPRESSION = 1;

	/**
	 * The feature id for the '<em><b>Compare Right</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION__COMPARE_RIGHT = 2;

	/**
	 * The feature id for the '<em><b>Compare Left</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION__COMPARE_LEFT = 3;

	/**
	 * The number of structural features of the '<em>Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPRESSION_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ProducerPortImpl <em>Producer Port</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ProducerPortImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getProducerPort()
	 * @generated
	 */
	int PRODUCER_PORT = 10;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__NAME = PORT__NAME;

	/**
	 * The feature id for the '<em><b>Token Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__TOKEN_TYPE = PORT__TOKEN_TYPE;

	/**
	 * The feature id for the '<em><b>Component</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__COMPONENT = PORT__COMPONENT;

	/**
	 * The feature id for the '<em><b>Connection To</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__CONNECTION_TO = PORT__CONNECTION_TO;

	/**
	 * The feature id for the '<em><b>Connection From</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__CONNECTION_FROM = PORT__CONNECTION_FROM;

	/**
	 * The feature id for the '<em><b>Consumer Port Expression</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__CONSUMER_PORT_EXPRESSION = PORT__CONSUMER_PORT_EXPRESSION;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__APPLICATION = PORT__APPLICATION;

	/**
	 * The feature id for the '<em><b>Output Attribute</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__OUTPUT_ATTRIBUTE = PORT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Event Emit Expression</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT__EVENT_EMIT_EXPRESSION = PORT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Producer Port</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PRODUCER_PORT_FEATURE_COUNT = PORT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.AttributeImpl <em>Attribute</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.AttributeImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getAttribute()
	 * @generated
	 */
	int ATTRIBUTE = 11;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__NAME = 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__TYPE = 1;

	/**
	 * The feature id for the '<em><b>Internal Component Type</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE__INTERNAL_COMPONENT_TYPE = 2;

	/**
	 * The number of structural features of the '<em>Attribute</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATTRIBUTE_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.InternalComponentTypeImpl <em>Internal Component Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.InternalComponentTypeImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getInternalComponentType()
	 * @generated
	 */
	int INTERNAL_COMPONENT_TYPE = 12;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_COMPONENT_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Tool</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_COMPONENT_TYPE__TOOL = COMPONENT_TYPE__TOOL;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_COMPONENT_TYPE__PORTS = COMPONENT_TYPE__PORTS;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_COMPONENT_TYPE__COMPONENT = COMPONENT_TYPE__COMPONENT;

	/**
	 * The feature id for the '<em><b>Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_COMPONENT_TYPE__MODULE = COMPONENT_TYPE__MODULE;

	/**
	 * The feature id for the '<em><b>Attributes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_COMPONENT_TYPE__ATTRIBUTES = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Internal Component Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERNAL_COMPONENT_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.SimpleExpressionImpl <em>Simple Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.SimpleExpressionImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getSimpleExpression()
	 * @generated
	 */
	int SIMPLE_EXPRESSION = 14;

	/**
	 * The feature id for the '<em><b>Producer Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_EXPRESSION__PRODUCER_PORT = EXPRESSION__PRODUCER_PORT;

	/**
	 * The feature id for the '<em><b>Unary Expression</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_EXPRESSION__UNARY_EXPRESSION = EXPRESSION__UNARY_EXPRESSION;

	/**
	 * The feature id for the '<em><b>Compare Right</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_EXPRESSION__COMPARE_RIGHT = EXPRESSION__COMPARE_RIGHT;

	/**
	 * The feature id for the '<em><b>Compare Left</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_EXPRESSION__COMPARE_LEFT = EXPRESSION__COMPARE_LEFT;

	/**
	 * The number of structural features of the '<em>Simple Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SIMPLE_EXPRESSION_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.UnaryExpressionImpl <em>Unary Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.UnaryExpressionImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getUnaryExpression()
	 * @generated
	 */
	int UNARY_EXPRESSION = 13;

	/**
	 * The feature id for the '<em><b>Producer Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_EXPRESSION__PRODUCER_PORT = SIMPLE_EXPRESSION__PRODUCER_PORT;

	/**
	 * The feature id for the '<em><b>Unary Expression</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_EXPRESSION__UNARY_EXPRESSION = SIMPLE_EXPRESSION__UNARY_EXPRESSION;

	/**
	 * The feature id for the '<em><b>Compare Right</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_EXPRESSION__COMPARE_RIGHT = SIMPLE_EXPRESSION__COMPARE_RIGHT;

	/**
	 * The feature id for the '<em><b>Compare Left</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_EXPRESSION__COMPARE_LEFT = SIMPLE_EXPRESSION__COMPARE_LEFT;

	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_EXPRESSION__OPERATOR = SIMPLE_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_EXPRESSION__EXPRESSION = SIMPLE_EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Unary Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_EXPRESSION_FEATURE_COUNT = SIMPLE_EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.BinaryExpressionImpl <em>Binary Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.BinaryExpressionImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getBinaryExpression()
	 * @generated
	 */
	int BINARY_EXPRESSION = 15;

	/**
	 * The feature id for the '<em><b>Producer Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_EXPRESSION__PRODUCER_PORT = EXPRESSION__PRODUCER_PORT;

	/**
	 * The feature id for the '<em><b>Unary Expression</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_EXPRESSION__UNARY_EXPRESSION = EXPRESSION__UNARY_EXPRESSION;

	/**
	 * The feature id for the '<em><b>Compare Right</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_EXPRESSION__COMPARE_RIGHT = EXPRESSION__COMPARE_RIGHT;

	/**
	 * The feature id for the '<em><b>Compare Left</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_EXPRESSION__COMPARE_LEFT = EXPRESSION__COMPARE_LEFT;

	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_EXPRESSION__OPERATOR = EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Left Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_EXPRESSION__LEFT_EXPRESSION = EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Right Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_EXPRESSION__RIGHT_EXPRESSION = EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Binary Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_EXPRESSION_FEATURE_COUNT = EXPRESSION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ConnectionImpl <em>Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ConnectionImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getConnection()
	 * @generated
	 */
	int CONNECTION = 16;

	/**
	 * The feature id for the '<em><b>From Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__FROM_COMPONENT = 0;

	/**
	 * The feature id for the '<em><b>Connection Configuration Step</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__CONNECTION_CONFIGURATION_STEP = 1;

	/**
	 * The feature id for the '<em><b>From Application</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__FROM_APPLICATION = 2;

	/**
	 * The feature id for the '<em><b>To Application</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__TO_APPLICATION = 3;

	/**
	 * The feature id for the '<em><b>To Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__TO_PORT = 4;

	/**
	 * The feature id for the '<em><b>From Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__FROM_PORT = 5;

	/**
	 * The feature id for the '<em><b>To Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__TO_COMPONENT = 6;

	/**
	 * The number of structural features of the '<em>Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ConnectionConfigurationStepImpl <em>Connection Configuration Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ConnectionConfigurationStepImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getConnectionConfigurationStep()
	 * @generated
	 */
	int CONNECTION_CONFIGURATION_STEP = 17;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_CONFIGURATION_STEP__APPLICATION = CONFIGURATION_STEP__APPLICATION;

	/**
	 * The feature id for the '<em><b>State Transition</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_CONFIGURATION_STEP__STATE_TRANSITION = CONFIGURATION_STEP__STATE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_CONFIGURATION_STEP__CONNECTION = CONFIGURATION_STEP_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Connection Configuration Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_CONFIGURATION_STEP_FEATURE_COUNT = CONFIGURATION_STEP_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.PortExpressionImpl <em>Port Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.PortExpressionImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getPortExpression()
	 * @generated
	 */
	int PORT_EXPRESSION = 18;

	/**
	 * The feature id for the '<em><b>Producer Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_EXPRESSION__PRODUCER_PORT = SIMPLE_EXPRESSION__PRODUCER_PORT;

	/**
	 * The feature id for the '<em><b>Unary Expression</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_EXPRESSION__UNARY_EXPRESSION = SIMPLE_EXPRESSION__UNARY_EXPRESSION;

	/**
	 * The feature id for the '<em><b>Compare Right</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_EXPRESSION__COMPARE_RIGHT = SIMPLE_EXPRESSION__COMPARE_RIGHT;

	/**
	 * The feature id for the '<em><b>Compare Left</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_EXPRESSION__COMPARE_LEFT = SIMPLE_EXPRESSION__COMPARE_LEFT;

	/**
	 * The feature id for the '<em><b>Port</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_EXPRESSION__PORT = SIMPLE_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_EXPRESSION__COMPONENT = SIMPLE_EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Port Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PORT_EXPRESSION_FEATURE_COUNT = SIMPLE_EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.SafetyClauseImpl <em>Safety Clause</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.SafetyClauseImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getSafetyClause()
	 * @generated
	 */
	int SAFETY_CLAUSE = 19;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAFETY_CLAUSE__EXPRESSION = 0;

	/**
	 * The number of structural features of the '<em>Safety Clause</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAFETY_CLAUSE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.LiteralExpressionImpl <em>Literal Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.LiteralExpressionImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getLiteralExpression()
	 * @generated
	 */
	int LITERAL_EXPRESSION = 20;

	/**
	 * The feature id for the '<em><b>Producer Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_EXPRESSION__PRODUCER_PORT = SIMPLE_EXPRESSION__PRODUCER_PORT;

	/**
	 * The feature id for the '<em><b>Unary Expression</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_EXPRESSION__UNARY_EXPRESSION = SIMPLE_EXPRESSION__UNARY_EXPRESSION;

	/**
	 * The feature id for the '<em><b>Compare Right</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_EXPRESSION__COMPARE_RIGHT = SIMPLE_EXPRESSION__COMPARE_RIGHT;

	/**
	 * The feature id for the '<em><b>Compare Left</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_EXPRESSION__COMPARE_LEFT = SIMPLE_EXPRESSION__COMPARE_LEFT;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_EXPRESSION__VALUE = SIMPLE_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Literal Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LITERAL_EXPRESSION_FEATURE_COUNT = SIMPLE_EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.EventTypeImpl <em>Event Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.EventTypeImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getEventType()
	 * @generated
	 */
	int EVENT_TYPE = 21;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TYPE__NAME = TOKEN_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TYPE__MODULE = TOKEN_TYPE__MODULE;

	/**
	 * The feature id for the '<em><b>Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TYPE__PORT = TOKEN_TYPE__PORT;

	/**
	 * The number of structural features of the '<em>Event Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_TYPE_FEATURE_COUNT = TOKEN_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.StreamTypeImpl <em>Stream Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.StreamTypeImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getStreamType()
	 * @generated
	 */
	int STREAM_TYPE = 22;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STREAM_TYPE__NAME = TOKEN_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STREAM_TYPE__MODULE = TOKEN_TYPE__MODULE;

	/**
	 * The feature id for the '<em><b>Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STREAM_TYPE__PORT = TOKEN_TYPE__PORT;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STREAM_TYPE__TYPE = TOKEN_TYPE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Stream Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STREAM_TYPE_FEATURE_COUNT = TOKEN_TYPE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ControlComponentTypeImpl <em>Control Component Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ControlComponentTypeImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getControlComponentType()
	 * @generated
	 */
	int CONTROL_COMPONENT_TYPE = 23;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_COMPONENT_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Tool</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_COMPONENT_TYPE__TOOL = COMPONENT_TYPE__TOOL;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_COMPONENT_TYPE__PORTS = COMPONENT_TYPE__PORTS;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_COMPONENT_TYPE__COMPONENT = COMPONENT_TYPE__COMPONENT;

	/**
	 * The feature id for the '<em><b>Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_COMPONENT_TYPE__MODULE = COMPONENT_TYPE__MODULE;

	/**
	 * The number of structural features of the '<em>Control Component Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTROL_COMPONENT_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ProcessingComponentTypeImpl <em>Processing Component Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ProcessingComponentTypeImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getProcessingComponentType()
	 * @generated
	 */
	int PROCESSING_COMPONENT_TYPE = 24;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_COMPONENT_TYPE__NAME = COMPONENT_TYPE__NAME;

	/**
	 * The feature id for the '<em><b>Tool</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_COMPONENT_TYPE__TOOL = COMPONENT_TYPE__TOOL;

	/**
	 * The feature id for the '<em><b>Ports</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_COMPONENT_TYPE__PORTS = COMPONENT_TYPE__PORTS;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_COMPONENT_TYPE__COMPONENT = COMPONENT_TYPE__COMPONENT;

	/**
	 * The feature id for the '<em><b>Module</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_COMPONENT_TYPE__MODULE = COMPONENT_TYPE__MODULE;

	/**
	 * The number of structural features of the '<em>Processing Component Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESSING_COMPONENT_TYPE_FEATURE_COUNT = COMPONENT_TYPE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ActivateComponentStepImpl <em>Activate Component Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ActivateComponentStepImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getActivateComponentStep()
	 * @generated
	 */
	int ACTIVATE_COMPONENT_STEP = 25;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_COMPONENT_STEP__APPLICATION = COMPONENT_CONFIGURATION_STEP__APPLICATION;

	/**
	 * The feature id for the '<em><b>State Transition</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_COMPONENT_STEP__STATE_TRANSITION = COMPONENT_CONFIGURATION_STEP__STATE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_COMPONENT_STEP__COMPONENT = COMPONENT_CONFIGURATION_STEP__COMPONENT;

	/**
	 * The number of structural features of the '<em>Activate Component Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_COMPONENT_STEP_FEATURE_COUNT = COMPONENT_CONFIGURATION_STEP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.DeactivateComponentStepImpl <em>Deactivate Component Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.DeactivateComponentStepImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getDeactivateComponentStep()
	 * @generated
	 */
	int DEACTIVATE_COMPONENT_STEP = 26;

	/**
	 * The feature id for the '<em><b>Application</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEACTIVATE_COMPONENT_STEP__APPLICATION = COMPONENT_CONFIGURATION_STEP__APPLICATION;

	/**
	 * The feature id for the '<em><b>State Transition</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEACTIVATE_COMPONENT_STEP__STATE_TRANSITION = COMPONENT_CONFIGURATION_STEP__STATE_TRANSITION;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEACTIVATE_COMPONENT_STEP__COMPONENT = COMPONENT_CONFIGURATION_STEP__COMPONENT;

	/**
	 * The number of structural features of the '<em>Deactivate Component Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEACTIVATE_COMPONENT_STEP_FEATURE_COUNT = COMPONENT_CONFIGURATION_STEP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.AlwaysClauseImpl <em>Always Clause</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.AlwaysClauseImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getAlwaysClause()
	 * @generated
	 */
	int ALWAYS_CLAUSE = 27;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALWAYS_CLAUSE__EXPRESSION = SAFETY_CLAUSE__EXPRESSION;

	/**
	 * The number of structural features of the '<em>Always Clause</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALWAYS_CLAUSE_FEATURE_COUNT = SAFETY_CLAUSE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.NeverClauseImpl <em>Never Clause</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.NeverClauseImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getNeverClause()
	 * @generated
	 */
	int NEVER_CLAUSE = 28;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEVER_CLAUSE__EXPRESSION = SAFETY_CLAUSE__EXPRESSION;

	/**
	 * The number of structural features of the '<em>Never Clause</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NEVER_CLAUSE_FEATURE_COUNT = SAFETY_CLAUSE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.impl.ActiveExpressionImpl <em>Active Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.impl.ActiveExpressionImpl
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getActiveExpression()
	 * @generated
	 */
	int ACTIVE_EXPRESSION = 29;

	/**
	 * The feature id for the '<em><b>Producer Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVE_EXPRESSION__PRODUCER_PORT = SIMPLE_EXPRESSION__PRODUCER_PORT;

	/**
	 * The feature id for the '<em><b>Unary Expression</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVE_EXPRESSION__UNARY_EXPRESSION = SIMPLE_EXPRESSION__UNARY_EXPRESSION;

	/**
	 * The feature id for the '<em><b>Compare Right</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVE_EXPRESSION__COMPARE_RIGHT = SIMPLE_EXPRESSION__COMPARE_RIGHT;

	/**
	 * The feature id for the '<em><b>Compare Left</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVE_EXPRESSION__COMPARE_LEFT = SIMPLE_EXPRESSION__COMPARE_LEFT;

	/**
	 * The feature id for the '<em><b>Active</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVE_EXPRESSION__ACTIVE = SIMPLE_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVE_EXPRESSION__COMPONENT = SIMPLE_EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Active Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVE_EXPRESSION_FEATURE_COUNT = SIMPLE_EXPRESSION_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.DataType <em>Data Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.DataType
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getDataType()
	 * @generated
	 */
	int DATA_TYPE = 30;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.UnaryOperator <em>Unary Operator</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.UnaryOperator
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getUnaryOperator()
	 * @generated
	 */
	int UNARY_OPERATOR = 31;

	/**
	 * The meta object id for the '{@link fr.supelec.adlv.BinaryOperator <em>Binary Operator</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.adlv.BinaryOperator
	 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getBinaryOperator()
	 * @generated
	 */
	int BINARY_OPERATOR = 32;


	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.Application <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Application</em>'.
	 * @see fr.supelec.adlv.Application
	 * @generated
	 */
	EClass getApplication();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.Application#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.adlv.Application#getName()
	 * @see #getApplication()
	 * @generated
	 */
	EAttribute getApplication_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.Application#getPorts <em>Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Ports</em>'.
	 * @see fr.supelec.adlv.Application#getPorts()
	 * @see #getApplication()
	 * @generated
	 */
	EReference getApplication_Ports();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.Application#getModule <em>Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Module</em>'.
	 * @see fr.supelec.adlv.Application#getModule()
	 * @see #getApplication()
	 * @generated
	 */
	EReference getApplication_Module();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.Application#getInitialSteps <em>Initial Steps</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Initial Steps</em>'.
	 * @see fr.supelec.adlv.Application#getInitialSteps()
	 * @see #getApplication()
	 * @generated
	 */
	EReference getApplication_InitialSteps();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Application#getOutputConnection <em>Output Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Output Connection</em>'.
	 * @see fr.supelec.adlv.Application#getOutputConnection()
	 * @see #getApplication()
	 * @generated
	 */
	EReference getApplication_OutputConnection();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Application#getInputConnection <em>Input Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Input Connection</em>'.
	 * @see fr.supelec.adlv.Application#getInputConnection()
	 * @see #getApplication()
	 * @generated
	 */
	EReference getApplication_InputConnection();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.Application#getComponents <em>Components</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Components</em>'.
	 * @see fr.supelec.adlv.Application#getComponents()
	 * @see #getApplication()
	 * @generated
	 */
	EReference getApplication_Components();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Application#getSafetyClause <em>Safety Clause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Safety Clause</em>'.
	 * @see fr.supelec.adlv.Application#getSafetyClause()
	 * @see #getApplication()
	 * @generated
	 */
	EReference getApplication_SafetyClause();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.Application#getStaticConfiguration <em>Static Configuration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Static Configuration</em>'.
	 * @see fr.supelec.adlv.Application#getStaticConfiguration()
	 * @see #getApplication()
	 * @generated
	 */
	EReference getApplication_StaticConfiguration();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.Port <em>Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port</em>'.
	 * @see fr.supelec.adlv.Port
	 * @generated
	 */
	EClass getPort();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.Port#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.adlv.Port#getName()
	 * @see #getPort()
	 * @generated
	 */
	EAttribute getPort_Name();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.Port#getTokenType <em>Token Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Token Type</em>'.
	 * @see fr.supelec.adlv.Port#getTokenType()
	 * @see #getPort()
	 * @generated
	 */
	EReference getPort_TokenType();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.Port#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Component</em>'.
	 * @see fr.supelec.adlv.Port#getComponent()
	 * @see #getPort()
	 * @generated
	 */
	EReference getPort_Component();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Port#getConnectionTo <em>Connection To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Connection To</em>'.
	 * @see fr.supelec.adlv.Port#getConnectionTo()
	 * @see #getPort()
	 * @generated
	 */
	EReference getPort_ConnectionTo();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Port#getConnectionFrom <em>Connection From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Connection From</em>'.
	 * @see fr.supelec.adlv.Port#getConnectionFrom()
	 * @see #getPort()
	 * @generated
	 */
	EReference getPort_ConnectionFrom();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Port#getConsumerPortExpression <em>Consumer Port Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Consumer Port Expression</em>'.
	 * @see fr.supelec.adlv.Port#getConsumerPortExpression()
	 * @see #getPort()
	 * @generated
	 */
	EReference getPort_ConsumerPortExpression();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.Port#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Application</em>'.
	 * @see fr.supelec.adlv.Port#getApplication()
	 * @see #getPort()
	 * @generated
	 */
	EReference getPort_Application();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.TokenType <em>Token Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Token Type</em>'.
	 * @see fr.supelec.adlv.TokenType
	 * @generated
	 */
	EClass getTokenType();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.TokenType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.adlv.TokenType#getName()
	 * @see #getTokenType()
	 * @generated
	 */
	EAttribute getTokenType_Name();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.TokenType#getModule <em>Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Module</em>'.
	 * @see fr.supelec.adlv.TokenType#getModule()
	 * @see #getTokenType()
	 * @generated
	 */
	EReference getTokenType_Module();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.TokenType#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Port</em>'.
	 * @see fr.supelec.adlv.TokenType#getPort()
	 * @see #getTokenType()
	 * @generated
	 */
	EReference getTokenType_Port();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.Module <em>Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Module</em>'.
	 * @see fr.supelec.adlv.Module
	 * @generated
	 */
	EClass getModule();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.Module#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.adlv.Module#getName()
	 * @see #getModule()
	 * @generated
	 */
	EAttribute getModule_Name();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.Module#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Application</em>'.
	 * @see fr.supelec.adlv.Module#getApplication()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_Application();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.Module#getComponentTypes <em>Component Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Component Types</em>'.
	 * @see fr.supelec.adlv.Module#getComponentTypes()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_ComponentTypes();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.Module#getTokenTypes <em>Token Types</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Token Types</em>'.
	 * @see fr.supelec.adlv.Module#getTokenTypes()
	 * @see #getModule()
	 * @generated
	 */
	EReference getModule_TokenTypes();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ComponentType <em>Component Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Type</em>'.
	 * @see fr.supelec.adlv.ComponentType
	 * @generated
	 */
	EClass getComponentType();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.ComponentType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.adlv.ComponentType#getName()
	 * @see #getComponentType()
	 * @generated
	 */
	EAttribute getComponentType_Name();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.ComponentType#getTool <em>Tool</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Tool</em>'.
	 * @see fr.supelec.adlv.ComponentType#getTool()
	 * @see #getComponentType()
	 * @generated
	 */
	EAttribute getComponentType_Tool();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.ComponentType#getPorts <em>Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Ports</em>'.
	 * @see fr.supelec.adlv.ComponentType#getPorts()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_Ports();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.ComponentType#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Component</em>'.
	 * @see fr.supelec.adlv.ComponentType#getComponent()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_Component();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.ComponentType#getModule <em>Module</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Module</em>'.
	 * @see fr.supelec.adlv.ComponentType#getModule()
	 * @see #getComponentType()
	 * @generated
	 */
	EReference getComponentType_Module();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.Component <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component</em>'.
	 * @see fr.supelec.adlv.Component
	 * @generated
	 */
	EClass getComponent();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.Component#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.adlv.Component#getName()
	 * @see #getComponent()
	 * @generated
	 */
	EAttribute getComponent_Name();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Component#getComponentConfigurationStep <em>Component Configuration Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Component Configuration Step</em>'.
	 * @see fr.supelec.adlv.Component#getComponentConfigurationStep()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_ComponentConfigurationStep();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Component#getInputConnection <em>Input Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Input Connection</em>'.
	 * @see fr.supelec.adlv.Component#getInputConnection()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_InputConnection();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Component#getOutputConnection <em>Output Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Output Connection</em>'.
	 * @see fr.supelec.adlv.Component#getOutputConnection()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_OutputConnection();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.Component#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Application</em>'.
	 * @see fr.supelec.adlv.Component#getApplication()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_Application();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Component#getConsumerPortExpression <em>Consumer Port Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Consumer Port Expression</em>'.
	 * @see fr.supelec.adlv.Component#getConsumerPortExpression()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_ConsumerPortExpression();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.Component#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see fr.supelec.adlv.Component#getType()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_Type();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ComponentConfigurationStep <em>Component Configuration Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Configuration Step</em>'.
	 * @see fr.supelec.adlv.ComponentConfigurationStep
	 * @generated
	 */
	EClass getComponentConfigurationStep();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.ComponentConfigurationStep#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Component</em>'.
	 * @see fr.supelec.adlv.ComponentConfigurationStep#getComponent()
	 * @see #getComponentConfigurationStep()
	 * @generated
	 */
	EReference getComponentConfigurationStep_Component();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ConfigurationStep <em>Configuration Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Configuration Step</em>'.
	 * @see fr.supelec.adlv.ConfigurationStep
	 * @generated
	 */
	EClass getConfigurationStep();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.ConfigurationStep#getApplication <em>Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Application</em>'.
	 * @see fr.supelec.adlv.ConfigurationStep#getApplication()
	 * @see #getConfigurationStep()
	 * @generated
	 */
	EReference getConfigurationStep_Application();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.ConfigurationStep#getStateTransition <em>State Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>State Transition</em>'.
	 * @see fr.supelec.adlv.ConfigurationStep#getStateTransition()
	 * @see #getConfigurationStep()
	 * @generated
	 */
	EReference getConfigurationStep_StateTransition();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ConsumerPort <em>Consumer Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Consumer Port</em>'.
	 * @see fr.supelec.adlv.ConsumerPort
	 * @generated
	 */
	EClass getConsumerPort();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.ConsumerPort#getSetExpression <em>Set Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Set Expression</em>'.
	 * @see fr.supelec.adlv.ConsumerPort#getSetExpression()
	 * @see #getConsumerPort()
	 * @generated
	 */
	EReference getConsumerPort_SetExpression();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.ConsumerPort#getSetAttribute <em>Set Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Set Attribute</em>'.
	 * @see fr.supelec.adlv.ConsumerPort#getSetAttribute()
	 * @see #getConsumerPort()
	 * @generated
	 */
	EReference getConsumerPort_SetAttribute();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.ConsumerPort#getSteps <em>Steps</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Steps</em>'.
	 * @see fr.supelec.adlv.ConsumerPort#getSteps()
	 * @see #getConsumerPort()
	 * @generated
	 */
	EReference getConsumerPort_Steps();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.Expression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expression</em>'.
	 * @see fr.supelec.adlv.Expression
	 * @generated
	 */
	EClass getExpression();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Expression#getProducerPort <em>Producer Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Producer Port</em>'.
	 * @see fr.supelec.adlv.Expression#getProducerPort()
	 * @see #getExpression()
	 * @generated
	 */
	EReference getExpression_ProducerPort();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.Expression#getUnaryExpression <em>Unary Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Unary Expression</em>'.
	 * @see fr.supelec.adlv.Expression#getUnaryExpression()
	 * @see #getExpression()
	 * @generated
	 */
	EReference getExpression_UnaryExpression();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.Expression#getCompareRight <em>Compare Right</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Compare Right</em>'.
	 * @see fr.supelec.adlv.Expression#getCompareRight()
	 * @see #getExpression()
	 * @generated
	 */
	EReference getExpression_CompareRight();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.Expression#getCompareLeft <em>Compare Left</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Compare Left</em>'.
	 * @see fr.supelec.adlv.Expression#getCompareLeft()
	 * @see #getExpression()
	 * @generated
	 */
	EReference getExpression_CompareLeft();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ProducerPort <em>Producer Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Producer Port</em>'.
	 * @see fr.supelec.adlv.ProducerPort
	 * @generated
	 */
	EClass getProducerPort();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.ProducerPort#getOutputAttribute <em>Output Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Output Attribute</em>'.
	 * @see fr.supelec.adlv.ProducerPort#getOutputAttribute()
	 * @see #getProducerPort()
	 * @generated
	 */
	EReference getProducerPort_OutputAttribute();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.ProducerPort#getEventEmitExpression <em>Event Emit Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Event Emit Expression</em>'.
	 * @see fr.supelec.adlv.ProducerPort#getEventEmitExpression()
	 * @see #getProducerPort()
	 * @generated
	 */
	EReference getProducerPort_EventEmitExpression();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.Attribute <em>Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Attribute</em>'.
	 * @see fr.supelec.adlv.Attribute
	 * @generated
	 */
	EClass getAttribute();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.Attribute#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.adlv.Attribute#getName()
	 * @see #getAttribute()
	 * @generated
	 */
	EAttribute getAttribute_Name();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.Attribute#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.supelec.adlv.Attribute#getType()
	 * @see #getAttribute()
	 * @generated
	 */
	EAttribute getAttribute_Type();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.adlv.Attribute#getInternalComponentType <em>Internal Component Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Internal Component Type</em>'.
	 * @see fr.supelec.adlv.Attribute#getInternalComponentType()
	 * @see #getAttribute()
	 * @generated
	 */
	EReference getAttribute_InternalComponentType();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.InternalComponentType <em>Internal Component Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Internal Component Type</em>'.
	 * @see fr.supelec.adlv.InternalComponentType
	 * @generated
	 */
	EClass getInternalComponentType();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.adlv.InternalComponentType#getAttributes <em>Attributes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Attributes</em>'.
	 * @see fr.supelec.adlv.InternalComponentType#getAttributes()
	 * @see #getInternalComponentType()
	 * @generated
	 */
	EReference getInternalComponentType_Attributes();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.UnaryExpression <em>Unary Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Expression</em>'.
	 * @see fr.supelec.adlv.UnaryExpression
	 * @generated
	 */
	EClass getUnaryExpression();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.UnaryExpression#getOperator <em>Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see fr.supelec.adlv.UnaryExpression#getOperator()
	 * @see #getUnaryExpression()
	 * @generated
	 */
	EAttribute getUnaryExpression_Operator();

	/**
	 * Returns the meta object for the containment reference '{@link fr.supelec.adlv.UnaryExpression#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expression</em>'.
	 * @see fr.supelec.adlv.UnaryExpression#getExpression()
	 * @see #getUnaryExpression()
	 * @generated
	 */
	EReference getUnaryExpression_Expression();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.SimpleExpression <em>Simple Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Simple Expression</em>'.
	 * @see fr.supelec.adlv.SimpleExpression
	 * @generated
	 */
	EClass getSimpleExpression();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.BinaryExpression <em>Binary Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Expression</em>'.
	 * @see fr.supelec.adlv.BinaryExpression
	 * @generated
	 */
	EClass getBinaryExpression();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.BinaryExpression#getOperator <em>Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see fr.supelec.adlv.BinaryExpression#getOperator()
	 * @see #getBinaryExpression()
	 * @generated
	 */
	EAttribute getBinaryExpression_Operator();

	/**
	 * Returns the meta object for the containment reference '{@link fr.supelec.adlv.BinaryExpression#getLeftExpression <em>Left Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Left Expression</em>'.
	 * @see fr.supelec.adlv.BinaryExpression#getLeftExpression()
	 * @see #getBinaryExpression()
	 * @generated
	 */
	EReference getBinaryExpression_LeftExpression();

	/**
	 * Returns the meta object for the containment reference '{@link fr.supelec.adlv.BinaryExpression#getRightExpression <em>Right Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Right Expression</em>'.
	 * @see fr.supelec.adlv.BinaryExpression#getRightExpression()
	 * @see #getBinaryExpression()
	 * @generated
	 */
	EReference getBinaryExpression_RightExpression();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.Connection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connection</em>'.
	 * @see fr.supelec.adlv.Connection
	 * @generated
	 */
	EClass getConnection();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.Connection#getFromComponent <em>From Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From Component</em>'.
	 * @see fr.supelec.adlv.Connection#getFromComponent()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_FromComponent();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.adlv.Connection#getConnectionConfigurationStep <em>Connection Configuration Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Connection Configuration Step</em>'.
	 * @see fr.supelec.adlv.Connection#getConnectionConfigurationStep()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_ConnectionConfigurationStep();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.Connection#getFromApplication <em>From Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From Application</em>'.
	 * @see fr.supelec.adlv.Connection#getFromApplication()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_FromApplication();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.Connection#getToApplication <em>To Application</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To Application</em>'.
	 * @see fr.supelec.adlv.Connection#getToApplication()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_ToApplication();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.Connection#getToPort <em>To Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To Port</em>'.
	 * @see fr.supelec.adlv.Connection#getToPort()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_ToPort();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.Connection#getFromPort <em>From Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>From Port</em>'.
	 * @see fr.supelec.adlv.Connection#getFromPort()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_FromPort();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.Connection#getToComponent <em>To Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To Component</em>'.
	 * @see fr.supelec.adlv.Connection#getToComponent()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_ToComponent();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ConnectionConfigurationStep <em>Connection Configuration Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connection Configuration Step</em>'.
	 * @see fr.supelec.adlv.ConnectionConfigurationStep
	 * @generated
	 */
	EClass getConnectionConfigurationStep();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.ConnectionConfigurationStep#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Connection</em>'.
	 * @see fr.supelec.adlv.ConnectionConfigurationStep#getConnection()
	 * @see #getConnectionConfigurationStep()
	 * @generated
	 */
	EReference getConnectionConfigurationStep_Connection();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.PortExpression <em>Port Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Port Expression</em>'.
	 * @see fr.supelec.adlv.PortExpression
	 * @generated
	 */
	EClass getPortExpression();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.PortExpression#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Port</em>'.
	 * @see fr.supelec.adlv.PortExpression#getPort()
	 * @see #getPortExpression()
	 * @generated
	 */
	EReference getPortExpression_Port();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.PortExpression#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Component</em>'.
	 * @see fr.supelec.adlv.PortExpression#getComponent()
	 * @see #getPortExpression()
	 * @generated
	 */
	EReference getPortExpression_Component();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.SafetyClause <em>Safety Clause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Safety Clause</em>'.
	 * @see fr.supelec.adlv.SafetyClause
	 * @generated
	 */
	EClass getSafetyClause();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.SafetyClause#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Expression</em>'.
	 * @see fr.supelec.adlv.SafetyClause#getExpression()
	 * @see #getSafetyClause()
	 * @generated
	 */
	EReference getSafetyClause_Expression();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.LiteralExpression <em>Literal Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Literal Expression</em>'.
	 * @see fr.supelec.adlv.LiteralExpression
	 * @generated
	 */
	EClass getLiteralExpression();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.LiteralExpression#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.supelec.adlv.LiteralExpression#getValue()
	 * @see #getLiteralExpression()
	 * @generated
	 */
	EAttribute getLiteralExpression_Value();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.EventType <em>Event Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Type</em>'.
	 * @see fr.supelec.adlv.EventType
	 * @generated
	 */
	EClass getEventType();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.StreamType <em>Stream Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Stream Type</em>'.
	 * @see fr.supelec.adlv.StreamType
	 * @generated
	 */
	EClass getStreamType();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.StreamType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see fr.supelec.adlv.StreamType#getType()
	 * @see #getStreamType()
	 * @generated
	 */
	EAttribute getStreamType_Type();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ControlComponentType <em>Control Component Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Control Component Type</em>'.
	 * @see fr.supelec.adlv.ControlComponentType
	 * @generated
	 */
	EClass getControlComponentType();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ProcessingComponentType <em>Processing Component Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Processing Component Type</em>'.
	 * @see fr.supelec.adlv.ProcessingComponentType
	 * @generated
	 */
	EClass getProcessingComponentType();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ActivateComponentStep <em>Activate Component Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activate Component Step</em>'.
	 * @see fr.supelec.adlv.ActivateComponentStep
	 * @generated
	 */
	EClass getActivateComponentStep();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.DeactivateComponentStep <em>Deactivate Component Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Deactivate Component Step</em>'.
	 * @see fr.supelec.adlv.DeactivateComponentStep
	 * @generated
	 */
	EClass getDeactivateComponentStep();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.AlwaysClause <em>Always Clause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Always Clause</em>'.
	 * @see fr.supelec.adlv.AlwaysClause
	 * @generated
	 */
	EClass getAlwaysClause();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.NeverClause <em>Never Clause</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Never Clause</em>'.
	 * @see fr.supelec.adlv.NeverClause
	 * @generated
	 */
	EClass getNeverClause();

	/**
	 * Returns the meta object for class '{@link fr.supelec.adlv.ActiveExpression <em>Active Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Active Expression</em>'.
	 * @see fr.supelec.adlv.ActiveExpression
	 * @generated
	 */
	EClass getActiveExpression();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.adlv.ActiveExpression#isActive <em>Active</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Active</em>'.
	 * @see fr.supelec.adlv.ActiveExpression#isActive()
	 * @see #getActiveExpression()
	 * @generated
	 */
	EAttribute getActiveExpression_Active();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.adlv.ActiveExpression#getComponent <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Component</em>'.
	 * @see fr.supelec.adlv.ActiveExpression#getComponent()
	 * @see #getActiveExpression()
	 * @generated
	 */
	EReference getActiveExpression_Component();

	/**
	 * Returns the meta object for enum '{@link fr.supelec.adlv.DataType <em>Data Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Data Type</em>'.
	 * @see fr.supelec.adlv.DataType
	 * @generated
	 */
	EEnum getDataType();

	/**
	 * Returns the meta object for enum '{@link fr.supelec.adlv.UnaryOperator <em>Unary Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Unary Operator</em>'.
	 * @see fr.supelec.adlv.UnaryOperator
	 * @generated
	 */
	EEnum getUnaryOperator();

	/**
	 * Returns the meta object for enum '{@link fr.supelec.adlv.BinaryOperator <em>Binary Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Binary Operator</em>'.
	 * @see fr.supelec.adlv.BinaryOperator
	 * @generated
	 */
	EEnum getBinaryOperator();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	AdlvFactory getAdlvFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ApplicationImpl <em>Application</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ApplicationImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getApplication()
		 * @generated
		 */
		EClass APPLICATION = eINSTANCE.getApplication();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute APPLICATION__NAME = eINSTANCE.getApplication_Name();

		/**
		 * The meta object literal for the '<em><b>Ports</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference APPLICATION__PORTS = eINSTANCE.getApplication_Ports();

		/**
		 * The meta object literal for the '<em><b>Module</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference APPLICATION__MODULE = eINSTANCE.getApplication_Module();

		/**
		 * The meta object literal for the '<em><b>Initial Steps</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference APPLICATION__INITIAL_STEPS = eINSTANCE.getApplication_InitialSteps();

		/**
		 * The meta object literal for the '<em><b>Output Connection</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference APPLICATION__OUTPUT_CONNECTION = eINSTANCE.getApplication_OutputConnection();

		/**
		 * The meta object literal for the '<em><b>Input Connection</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference APPLICATION__INPUT_CONNECTION = eINSTANCE.getApplication_InputConnection();

		/**
		 * The meta object literal for the '<em><b>Components</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference APPLICATION__COMPONENTS = eINSTANCE.getApplication_Components();

		/**
		 * The meta object literal for the '<em><b>Safety Clause</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference APPLICATION__SAFETY_CLAUSE = eINSTANCE.getApplication_SafetyClause();

		/**
		 * The meta object literal for the '<em><b>Static Configuration</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference APPLICATION__STATIC_CONFIGURATION = eINSTANCE.getApplication_StaticConfiguration();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.PortImpl <em>Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.PortImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getPort()
		 * @generated
		 */
		EClass PORT = eINSTANCE.getPort();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PORT__NAME = eINSTANCE.getPort_Name();

		/**
		 * The meta object literal for the '<em><b>Token Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT__TOKEN_TYPE = eINSTANCE.getPort_TokenType();

		/**
		 * The meta object literal for the '<em><b>Component</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT__COMPONENT = eINSTANCE.getPort_Component();

		/**
		 * The meta object literal for the '<em><b>Connection To</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT__CONNECTION_TO = eINSTANCE.getPort_ConnectionTo();

		/**
		 * The meta object literal for the '<em><b>Connection From</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT__CONNECTION_FROM = eINSTANCE.getPort_ConnectionFrom();

		/**
		 * The meta object literal for the '<em><b>Consumer Port Expression</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT__CONSUMER_PORT_EXPRESSION = eINSTANCE.getPort_ConsumerPortExpression();

		/**
		 * The meta object literal for the '<em><b>Application</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT__APPLICATION = eINSTANCE.getPort_Application();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.TokenTypeImpl <em>Token Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.TokenTypeImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getTokenType()
		 * @generated
		 */
		EClass TOKEN_TYPE = eINSTANCE.getTokenType();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TOKEN_TYPE__NAME = eINSTANCE.getTokenType_Name();

		/**
		 * The meta object literal for the '<em><b>Module</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TOKEN_TYPE__MODULE = eINSTANCE.getTokenType_Module();

		/**
		 * The meta object literal for the '<em><b>Port</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TOKEN_TYPE__PORT = eINSTANCE.getTokenType_Port();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ModuleImpl <em>Module</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ModuleImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getModule()
		 * @generated
		 */
		EClass MODULE = eINSTANCE.getModule();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODULE__NAME = eINSTANCE.getModule_Name();

		/**
		 * The meta object literal for the '<em><b>Application</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODULE__APPLICATION = eINSTANCE.getModule_Application();

		/**
		 * The meta object literal for the '<em><b>Component Types</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODULE__COMPONENT_TYPES = eINSTANCE.getModule_ComponentTypes();

		/**
		 * The meta object literal for the '<em><b>Token Types</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODULE__TOKEN_TYPES = eINSTANCE.getModule_TokenTypes();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ComponentTypeImpl <em>Component Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ComponentTypeImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getComponentType()
		 * @generated
		 */
		EClass COMPONENT_TYPE = eINSTANCE.getComponentType();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPONENT_TYPE__NAME = eINSTANCE.getComponentType_Name();

		/**
		 * The meta object literal for the '<em><b>Tool</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPONENT_TYPE__TOOL = eINSTANCE.getComponentType_Tool();

		/**
		 * The meta object literal for the '<em><b>Ports</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT_TYPE__PORTS = eINSTANCE.getComponentType_Ports();

		/**
		 * The meta object literal for the '<em><b>Component</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT_TYPE__COMPONENT = eINSTANCE.getComponentType_Component();

		/**
		 * The meta object literal for the '<em><b>Module</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT_TYPE__MODULE = eINSTANCE.getComponentType_Module();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ComponentImpl <em>Component</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ComponentImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getComponent()
		 * @generated
		 */
		EClass COMPONENT = eINSTANCE.getComponent();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPONENT__NAME = eINSTANCE.getComponent_Name();

		/**
		 * The meta object literal for the '<em><b>Component Configuration Step</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT__COMPONENT_CONFIGURATION_STEP = eINSTANCE.getComponent_ComponentConfigurationStep();

		/**
		 * The meta object literal for the '<em><b>Input Connection</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT__INPUT_CONNECTION = eINSTANCE.getComponent_InputConnection();

		/**
		 * The meta object literal for the '<em><b>Output Connection</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT__OUTPUT_CONNECTION = eINSTANCE.getComponent_OutputConnection();

		/**
		 * The meta object literal for the '<em><b>Application</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT__APPLICATION = eINSTANCE.getComponent_Application();

		/**
		 * The meta object literal for the '<em><b>Consumer Port Expression</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT__CONSUMER_PORT_EXPRESSION = eINSTANCE.getComponent_ConsumerPortExpression();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT__TYPE = eINSTANCE.getComponent_Type();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ComponentConfigurationStepImpl <em>Component Configuration Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ComponentConfigurationStepImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getComponentConfigurationStep()
		 * @generated
		 */
		EClass COMPONENT_CONFIGURATION_STEP = eINSTANCE.getComponentConfigurationStep();

		/**
		 * The meta object literal for the '<em><b>Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPONENT_CONFIGURATION_STEP__COMPONENT = eINSTANCE.getComponentConfigurationStep_Component();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ConfigurationStepImpl <em>Configuration Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ConfigurationStepImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getConfigurationStep()
		 * @generated
		 */
		EClass CONFIGURATION_STEP = eINSTANCE.getConfigurationStep();

		/**
		 * The meta object literal for the '<em><b>Application</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONFIGURATION_STEP__APPLICATION = eINSTANCE.getConfigurationStep_Application();

		/**
		 * The meta object literal for the '<em><b>State Transition</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONFIGURATION_STEP__STATE_TRANSITION = eINSTANCE.getConfigurationStep_StateTransition();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ConsumerPortImpl <em>Consumer Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ConsumerPortImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getConsumerPort()
		 * @generated
		 */
		EClass CONSUMER_PORT = eINSTANCE.getConsumerPort();

		/**
		 * The meta object literal for the '<em><b>Set Expression</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONSUMER_PORT__SET_EXPRESSION = eINSTANCE.getConsumerPort_SetExpression();

		/**
		 * The meta object literal for the '<em><b>Set Attribute</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONSUMER_PORT__SET_ATTRIBUTE = eINSTANCE.getConsumerPort_SetAttribute();

		/**
		 * The meta object literal for the '<em><b>Steps</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONSUMER_PORT__STEPS = eINSTANCE.getConsumerPort_Steps();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ExpressionImpl <em>Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ExpressionImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getExpression()
		 * @generated
		 */
		EClass EXPRESSION = eINSTANCE.getExpression();

		/**
		 * The meta object literal for the '<em><b>Producer Port</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPRESSION__PRODUCER_PORT = eINSTANCE.getExpression_ProducerPort();

		/**
		 * The meta object literal for the '<em><b>Unary Expression</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPRESSION__UNARY_EXPRESSION = eINSTANCE.getExpression_UnaryExpression();

		/**
		 * The meta object literal for the '<em><b>Compare Right</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPRESSION__COMPARE_RIGHT = eINSTANCE.getExpression_CompareRight();

		/**
		 * The meta object literal for the '<em><b>Compare Left</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPRESSION__COMPARE_LEFT = eINSTANCE.getExpression_CompareLeft();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ProducerPortImpl <em>Producer Port</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ProducerPortImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getProducerPort()
		 * @generated
		 */
		EClass PRODUCER_PORT = eINSTANCE.getProducerPort();

		/**
		 * The meta object literal for the '<em><b>Output Attribute</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PRODUCER_PORT__OUTPUT_ATTRIBUTE = eINSTANCE.getProducerPort_OutputAttribute();

		/**
		 * The meta object literal for the '<em><b>Event Emit Expression</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PRODUCER_PORT__EVENT_EMIT_EXPRESSION = eINSTANCE.getProducerPort_EventEmitExpression();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.AttributeImpl <em>Attribute</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.AttributeImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getAttribute()
		 * @generated
		 */
		EClass ATTRIBUTE = eINSTANCE.getAttribute();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ATTRIBUTE__NAME = eINSTANCE.getAttribute_Name();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ATTRIBUTE__TYPE = eINSTANCE.getAttribute_Type();

		/**
		 * The meta object literal for the '<em><b>Internal Component Type</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ATTRIBUTE__INTERNAL_COMPONENT_TYPE = eINSTANCE.getAttribute_InternalComponentType();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.InternalComponentTypeImpl <em>Internal Component Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.InternalComponentTypeImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getInternalComponentType()
		 * @generated
		 */
		EClass INTERNAL_COMPONENT_TYPE = eINSTANCE.getInternalComponentType();

		/**
		 * The meta object literal for the '<em><b>Attributes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERNAL_COMPONENT_TYPE__ATTRIBUTES = eINSTANCE.getInternalComponentType_Attributes();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.UnaryExpressionImpl <em>Unary Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.UnaryExpressionImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getUnaryExpression()
		 * @generated
		 */
		EClass UNARY_EXPRESSION = eINSTANCE.getUnaryExpression();

		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute UNARY_EXPRESSION__OPERATOR = eINSTANCE.getUnaryExpression_Operator();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNARY_EXPRESSION__EXPRESSION = eINSTANCE.getUnaryExpression_Expression();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.SimpleExpressionImpl <em>Simple Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.SimpleExpressionImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getSimpleExpression()
		 * @generated
		 */
		EClass SIMPLE_EXPRESSION = eINSTANCE.getSimpleExpression();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.BinaryExpressionImpl <em>Binary Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.BinaryExpressionImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getBinaryExpression()
		 * @generated
		 */
		EClass BINARY_EXPRESSION = eINSTANCE.getBinaryExpression();

		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BINARY_EXPRESSION__OPERATOR = eINSTANCE.getBinaryExpression_Operator();

		/**
		 * The meta object literal for the '<em><b>Left Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_EXPRESSION__LEFT_EXPRESSION = eINSTANCE.getBinaryExpression_LeftExpression();

		/**
		 * The meta object literal for the '<em><b>Right Expression</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_EXPRESSION__RIGHT_EXPRESSION = eINSTANCE.getBinaryExpression_RightExpression();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ConnectionImpl <em>Connection</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ConnectionImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getConnection()
		 * @generated
		 */
		EClass CONNECTION = eINSTANCE.getConnection();

		/**
		 * The meta object literal for the '<em><b>From Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__FROM_COMPONENT = eINSTANCE.getConnection_FromComponent();

		/**
		 * The meta object literal for the '<em><b>Connection Configuration Step</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__CONNECTION_CONFIGURATION_STEP = eINSTANCE.getConnection_ConnectionConfigurationStep();

		/**
		 * The meta object literal for the '<em><b>From Application</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__FROM_APPLICATION = eINSTANCE.getConnection_FromApplication();

		/**
		 * The meta object literal for the '<em><b>To Application</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__TO_APPLICATION = eINSTANCE.getConnection_ToApplication();

		/**
		 * The meta object literal for the '<em><b>To Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__TO_PORT = eINSTANCE.getConnection_ToPort();

		/**
		 * The meta object literal for the '<em><b>From Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__FROM_PORT = eINSTANCE.getConnection_FromPort();

		/**
		 * The meta object literal for the '<em><b>To Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION__TO_COMPONENT = eINSTANCE.getConnection_ToComponent();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ConnectionConfigurationStepImpl <em>Connection Configuration Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ConnectionConfigurationStepImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getConnectionConfigurationStep()
		 * @generated
		 */
		EClass CONNECTION_CONFIGURATION_STEP = eINSTANCE.getConnectionConfigurationStep();

		/**
		 * The meta object literal for the '<em><b>Connection</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONNECTION_CONFIGURATION_STEP__CONNECTION = eINSTANCE.getConnectionConfigurationStep_Connection();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.PortExpressionImpl <em>Port Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.PortExpressionImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getPortExpression()
		 * @generated
		 */
		EClass PORT_EXPRESSION = eINSTANCE.getPortExpression();

		/**
		 * The meta object literal for the '<em><b>Port</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT_EXPRESSION__PORT = eINSTANCE.getPortExpression_Port();

		/**
		 * The meta object literal for the '<em><b>Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PORT_EXPRESSION__COMPONENT = eINSTANCE.getPortExpression_Component();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.SafetyClauseImpl <em>Safety Clause</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.SafetyClauseImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getSafetyClause()
		 * @generated
		 */
		EClass SAFETY_CLAUSE = eINSTANCE.getSafetyClause();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SAFETY_CLAUSE__EXPRESSION = eINSTANCE.getSafetyClause_Expression();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.LiteralExpressionImpl <em>Literal Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.LiteralExpressionImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getLiteralExpression()
		 * @generated
		 */
		EClass LITERAL_EXPRESSION = eINSTANCE.getLiteralExpression();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute LITERAL_EXPRESSION__VALUE = eINSTANCE.getLiteralExpression_Value();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.EventTypeImpl <em>Event Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.EventTypeImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getEventType()
		 * @generated
		 */
		EClass EVENT_TYPE = eINSTANCE.getEventType();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.StreamTypeImpl <em>Stream Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.StreamTypeImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getStreamType()
		 * @generated
		 */
		EClass STREAM_TYPE = eINSTANCE.getStreamType();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STREAM_TYPE__TYPE = eINSTANCE.getStreamType_Type();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ControlComponentTypeImpl <em>Control Component Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ControlComponentTypeImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getControlComponentType()
		 * @generated
		 */
		EClass CONTROL_COMPONENT_TYPE = eINSTANCE.getControlComponentType();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ProcessingComponentTypeImpl <em>Processing Component Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ProcessingComponentTypeImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getProcessingComponentType()
		 * @generated
		 */
		EClass PROCESSING_COMPONENT_TYPE = eINSTANCE.getProcessingComponentType();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ActivateComponentStepImpl <em>Activate Component Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ActivateComponentStepImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getActivateComponentStep()
		 * @generated
		 */
		EClass ACTIVATE_COMPONENT_STEP = eINSTANCE.getActivateComponentStep();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.DeactivateComponentStepImpl <em>Deactivate Component Step</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.DeactivateComponentStepImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getDeactivateComponentStep()
		 * @generated
		 */
		EClass DEACTIVATE_COMPONENT_STEP = eINSTANCE.getDeactivateComponentStep();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.AlwaysClauseImpl <em>Always Clause</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.AlwaysClauseImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getAlwaysClause()
		 * @generated
		 */
		EClass ALWAYS_CLAUSE = eINSTANCE.getAlwaysClause();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.NeverClauseImpl <em>Never Clause</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.NeverClauseImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getNeverClause()
		 * @generated
		 */
		EClass NEVER_CLAUSE = eINSTANCE.getNeverClause();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.impl.ActiveExpressionImpl <em>Active Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.impl.ActiveExpressionImpl
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getActiveExpression()
		 * @generated
		 */
		EClass ACTIVE_EXPRESSION = eINSTANCE.getActiveExpression();

		/**
		 * The meta object literal for the '<em><b>Active</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ACTIVE_EXPRESSION__ACTIVE = eINSTANCE.getActiveExpression_Active();

		/**
		 * The meta object literal for the '<em><b>Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACTIVE_EXPRESSION__COMPONENT = eINSTANCE.getActiveExpression_Component();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.DataType <em>Data Type</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.DataType
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getDataType()
		 * @generated
		 */
		EEnum DATA_TYPE = eINSTANCE.getDataType();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.UnaryOperator <em>Unary Operator</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.UnaryOperator
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getUnaryOperator()
		 * @generated
		 */
		EEnum UNARY_OPERATOR = eINSTANCE.getUnaryOperator();

		/**
		 * The meta object literal for the '{@link fr.supelec.adlv.BinaryOperator <em>Binary Operator</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.adlv.BinaryOperator
		 * @see fr.supelec.adlv.impl.AdlvPackageImpl#getBinaryOperator()
		 * @generated
		 */
		EEnum BINARY_OPERATOR = eINSTANCE.getBinaryOperator();

	}

} //AdlvPackage
