/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Configuration Step</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.ConfigurationStep#getApplication <em>Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.ConfigurationStep#getStateTransition <em>State Transition</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getConfigurationStep()
 * @model abstract="true"
 * @generated
 */
public interface ConfigurationStep extends EObject {
	/**
	 * Returns the value of the '<em><b>Application</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Application#getInitialSteps <em>Initial Steps</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Application</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Application</em>' container reference.
	 * @see #setApplication(Application)
	 * @see fr.supelec.adlv.AdlvPackage#getConfigurationStep_Application()
	 * @see fr.supelec.adlv.Application#getInitialSteps
	 * @model opposite="initialSteps" transient="false" ordered="false"
	 * @generated
	 */
	Application getApplication();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ConfigurationStep#getApplication <em>Application</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Application</em>' container reference.
	 * @see #getApplication()
	 * @generated
	 */
	void setApplication(Application value);

	/**
	 * Returns the value of the '<em><b>State Transition</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ConsumerPort#getSteps <em>Steps</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>State Transition</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>State Transition</em>' container reference.
	 * @see #setStateTransition(ConsumerPort)
	 * @see fr.supelec.adlv.AdlvPackage#getConfigurationStep_StateTransition()
	 * @see fr.supelec.adlv.ConsumerPort#getSteps
	 * @model opposite="steps" transient="false" ordered="false"
	 * @generated
	 */
	ConsumerPort getStateTransition();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ConfigurationStep#getStateTransition <em>State Transition</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>State Transition</em>' container reference.
	 * @see #getStateTransition()
	 * @generated
	 */
	void setStateTransition(ConsumerPort value);

} // ConfigurationStep
