/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Connection</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.Connection#getFromComponent <em>From Component</em>}</li>
 *   <li>{@link fr.supelec.adlv.Connection#getConnectionConfigurationStep <em>Connection Configuration Step</em>}</li>
 *   <li>{@link fr.supelec.adlv.Connection#getFromApplication <em>From Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.Connection#getToApplication <em>To Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.Connection#getToPort <em>To Port</em>}</li>
 *   <li>{@link fr.supelec.adlv.Connection#getFromPort <em>From Port</em>}</li>
 *   <li>{@link fr.supelec.adlv.Connection#getToComponent <em>To Component</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getConnection()
 * @model
 * @generated
 */
public interface Connection extends EObject {
	/**
	 * Returns the value of the '<em><b>From Component</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Component#getOutputConnection <em>Output Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From Component</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From Component</em>' reference.
	 * @see #setFromComponent(Component)
	 * @see fr.supelec.adlv.AdlvPackage#getConnection_FromComponent()
	 * @see fr.supelec.adlv.Component#getOutputConnection
	 * @model opposite="outputConnection" ordered="false"
	 * @generated
	 */
	Component getFromComponent();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Connection#getFromComponent <em>From Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From Component</em>' reference.
	 * @see #getFromComponent()
	 * @generated
	 */
	void setFromComponent(Component value);

	/**
	 * Returns the value of the '<em><b>Connection Configuration Step</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.ConnectionConfigurationStep}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ConnectionConfigurationStep#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connection Configuration Step</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connection Configuration Step</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getConnection_ConnectionConfigurationStep()
	 * @see fr.supelec.adlv.ConnectionConfigurationStep#getConnection
	 * @model opposite="connection" ordered="false"
	 * @generated
	 */
	EList<ConnectionConfigurationStep> getConnectionConfigurationStep();

	/**
	 * Returns the value of the '<em><b>From Application</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Application#getOutputConnection <em>Output Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From Application</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From Application</em>' reference.
	 * @see #setFromApplication(Application)
	 * @see fr.supelec.adlv.AdlvPackage#getConnection_FromApplication()
	 * @see fr.supelec.adlv.Application#getOutputConnection
	 * @model opposite="outputConnection" ordered="false"
	 * @generated
	 */
	Application getFromApplication();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Connection#getFromApplication <em>From Application</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From Application</em>' reference.
	 * @see #getFromApplication()
	 * @generated
	 */
	void setFromApplication(Application value);

	/**
	 * Returns the value of the '<em><b>To Application</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Application#getInputConnection <em>Input Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To Application</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To Application</em>' reference.
	 * @see #setToApplication(Application)
	 * @see fr.supelec.adlv.AdlvPackage#getConnection_ToApplication()
	 * @see fr.supelec.adlv.Application#getInputConnection
	 * @model opposite="inputConnection" ordered="false"
	 * @generated
	 */
	Application getToApplication();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Connection#getToApplication <em>To Application</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To Application</em>' reference.
	 * @see #getToApplication()
	 * @generated
	 */
	void setToApplication(Application value);

	/**
	 * Returns the value of the '<em><b>To Port</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Port#getConnectionTo <em>Connection To</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To Port</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To Port</em>' reference.
	 * @see #setToPort(Port)
	 * @see fr.supelec.adlv.AdlvPackage#getConnection_ToPort()
	 * @see fr.supelec.adlv.Port#getConnectionTo
	 * @model opposite="connectionTo" required="true" ordered="false"
	 * @generated
	 */
	Port getToPort();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Connection#getToPort <em>To Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To Port</em>' reference.
	 * @see #getToPort()
	 * @generated
	 */
	void setToPort(Port value);

	/**
	 * Returns the value of the '<em><b>From Port</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Port#getConnectionFrom <em>Connection From</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From Port</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From Port</em>' reference.
	 * @see #setFromPort(Port)
	 * @see fr.supelec.adlv.AdlvPackage#getConnection_FromPort()
	 * @see fr.supelec.adlv.Port#getConnectionFrom
	 * @model opposite="connectionFrom" required="true" ordered="false"
	 * @generated
	 */
	Port getFromPort();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Connection#getFromPort <em>From Port</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From Port</em>' reference.
	 * @see #getFromPort()
	 * @generated
	 */
	void setFromPort(Port value);

	/**
	 * Returns the value of the '<em><b>To Component</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Component#getInputConnection <em>Input Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To Component</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To Component</em>' reference.
	 * @see #setToComponent(Component)
	 * @see fr.supelec.adlv.AdlvPackage#getConnection_ToComponent()
	 * @see fr.supelec.adlv.Component#getInputConnection
	 * @model opposite="inputConnection" ordered="false"
	 * @generated
	 */
	Component getToComponent();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Connection#getToComponent <em>To Component</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To Component</em>' reference.
	 * @see #getToComponent()
	 * @generated
	 */
	void setToComponent(Component value);

} // Connection
