/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Consumer Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.ConsumerPort#getSetExpression <em>Set Expression</em>}</li>
 *   <li>{@link fr.supelec.adlv.ConsumerPort#getSetAttribute <em>Set Attribute</em>}</li>
 *   <li>{@link fr.supelec.adlv.ConsumerPort#getSteps <em>Steps</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getConsumerPort()
 * @model
 * @generated
 */
public interface ConsumerPort extends Port {
	/**
	 * Returns the value of the '<em><b>Set Expression</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Set Expression</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Set Expression</em>' reference.
	 * @see #setSetExpression(Expression)
	 * @see fr.supelec.adlv.AdlvPackage#getConsumerPort_SetExpression()
	 * @model ordered="false"
	 * @generated
	 */
	Expression getSetExpression();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ConsumerPort#getSetExpression <em>Set Expression</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Set Expression</em>' reference.
	 * @see #getSetExpression()
	 * @generated
	 */
	void setSetExpression(Expression value);

	/**
	 * Returns the value of the '<em><b>Set Attribute</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Set Attribute</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Set Attribute</em>' reference.
	 * @see #setSetAttribute(Attribute)
	 * @see fr.supelec.adlv.AdlvPackage#getConsumerPort_SetAttribute()
	 * @model ordered="false"
	 * @generated
	 */
	Attribute getSetAttribute();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.ConsumerPort#getSetAttribute <em>Set Attribute</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Set Attribute</em>' reference.
	 * @see #getSetAttribute()
	 * @generated
	 */
	void setSetAttribute(Attribute value);

	/**
	 * Returns the value of the '<em><b>Steps</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.adlv.ConfigurationStep}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ConfigurationStep#getStateTransition <em>State Transition</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Steps</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Steps</em>' containment reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getConsumerPort_Steps()
	 * @see fr.supelec.adlv.ConfigurationStep#getStateTransition
	 * @model opposite="stateTransition" containment="true" ordered="false"
	 * @generated
	 */
	EList<ConfigurationStep> getSteps();

} // ConsumerPort
