/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Port</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.adlv.Port#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.adlv.Port#getTokenType <em>Token Type</em>}</li>
 *   <li>{@link fr.supelec.adlv.Port#getComponent <em>Component</em>}</li>
 *   <li>{@link fr.supelec.adlv.Port#getConnectionTo <em>Connection To</em>}</li>
 *   <li>{@link fr.supelec.adlv.Port#getConnectionFrom <em>Connection From</em>}</li>
 *   <li>{@link fr.supelec.adlv.Port#getConsumerPortExpression <em>Consumer Port Expression</em>}</li>
 *   <li>{@link fr.supelec.adlv.Port#getApplication <em>Application</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.adlv.AdlvPackage#getPort()
 * @model abstract="true"
 * @generated
 */
public interface Port extends EObject {
	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see fr.supelec.adlv.AdlvPackage#getPort_Name()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Port#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Token Type</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.TokenType#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Token Type</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Token Type</em>' reference.
	 * @see #setTokenType(TokenType)
	 * @see fr.supelec.adlv.AdlvPackage#getPort_TokenType()
	 * @see fr.supelec.adlv.TokenType#getPort
	 * @model opposite="port" required="true" ordered="false"
	 * @generated
	 */
	TokenType getTokenType();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Port#getTokenType <em>Token Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Token Type</em>' reference.
	 * @see #getTokenType()
	 * @generated
	 */
	void setTokenType(TokenType value);

	/**
	 * Returns the value of the '<em><b>Component</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.ComponentType#getPorts <em>Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Component</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Component</em>' container reference.
	 * @see #setComponent(ComponentType)
	 * @see fr.supelec.adlv.AdlvPackage#getPort_Component()
	 * @see fr.supelec.adlv.ComponentType#getPorts
	 * @model opposite="ports" transient="false" ordered="false"
	 * @generated
	 */
	ComponentType getComponent();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Port#getComponent <em>Component</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Component</em>' container reference.
	 * @see #getComponent()
	 * @generated
	 */
	void setComponent(ComponentType value);

	/**
	 * Returns the value of the '<em><b>Connection To</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Connection}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Connection#getToPort <em>To Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connection To</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connection To</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getPort_ConnectionTo()
	 * @see fr.supelec.adlv.Connection#getToPort
	 * @model opposite="toPort" ordered="false"
	 * @generated
	 */
	EList<Connection> getConnectionTo();

	/**
	 * Returns the value of the '<em><b>Connection From</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.Connection}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Connection#getFromPort <em>From Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Connection From</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Connection From</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getPort_ConnectionFrom()
	 * @see fr.supelec.adlv.Connection#getFromPort
	 * @model opposite="fromPort" ordered="false"
	 * @generated
	 */
	EList<Connection> getConnectionFrom();

	/**
	 * Returns the value of the '<em><b>Consumer Port Expression</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.adlv.PortExpression}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.PortExpression#getPort <em>Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Consumer Port Expression</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Consumer Port Expression</em>' reference list.
	 * @see fr.supelec.adlv.AdlvPackage#getPort_ConsumerPortExpression()
	 * @see fr.supelec.adlv.PortExpression#getPort
	 * @model opposite="port" ordered="false"
	 * @generated
	 */
	EList<PortExpression> getConsumerPortExpression();

	/**
	 * Returns the value of the '<em><b>Application</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.adlv.Application#getPorts <em>Ports</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Application</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Application</em>' container reference.
	 * @see #setApplication(Application)
	 * @see fr.supelec.adlv.AdlvPackage#getPort_Application()
	 * @see fr.supelec.adlv.Application#getPorts
	 * @model opposite="ports" transient="false" ordered="false"
	 * @generated
	 */
	Application getApplication();

	/**
	 * Sets the value of the '{@link fr.supelec.adlv.Port#getApplication <em>Application</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Application</em>' container reference.
	 * @see #getApplication()
	 * @generated
	 */
	void setApplication(Application value);

} // Port
