/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.AdlvPackage;
import fr.supelec.adlv.Application;
import fr.supelec.adlv.Component;
import fr.supelec.adlv.ConfigurationStep;
import fr.supelec.adlv.Connection;
import fr.supelec.adlv.Module;
import fr.supelec.adlv.Port;
import fr.supelec.adlv.SafetyClause;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Application</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getPorts <em>Ports</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getModule <em>Module</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getInitialSteps <em>Initial Steps</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getOutputConnection <em>Output Connection</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getInputConnection <em>Input Connection</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getComponents <em>Components</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getSafetyClause <em>Safety Clause</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ApplicationImpl#getStaticConfiguration <em>Static Configuration</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ApplicationImpl extends EObjectImpl implements Application {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getPorts() <em>Ports</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPorts()
	 * @generated
	 * @ordered
	 */
	protected EList<Port> ports;

	/**
	 * The cached value of the '{@link #getInitialSteps() <em>Initial Steps</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitialSteps()
	 * @generated
	 * @ordered
	 */
	protected EList<ConfigurationStep> initialSteps;

	/**
	 * The cached value of the '{@link #getOutputConnection() <em>Output Connection</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutputConnection()
	 * @generated
	 * @ordered
	 */
	protected EList<Connection> outputConnection;

	/**
	 * The cached value of the '{@link #getInputConnection() <em>Input Connection</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInputConnection()
	 * @generated
	 * @ordered
	 */
	protected EList<Connection> inputConnection;

	/**
	 * The cached value of the '{@link #getComponents() <em>Components</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponents()
	 * @generated
	 * @ordered
	 */
	protected EList<Component> components;

	/**
	 * The cached value of the '{@link #getSafetyClause() <em>Safety Clause</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSafetyClause()
	 * @generated
	 * @ordered
	 */
	protected EList<SafetyClause> safetyClause;

	/**
	 * The cached value of the '{@link #getStaticConfiguration() <em>Static Configuration</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStaticConfiguration()
	 * @generated
	 * @ordered
	 */
	protected EList<ConfigurationStep> staticConfiguration;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ApplicationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdlvPackage.Literals.APPLICATION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.APPLICATION__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Port> getPorts() {
		if (ports == null) {
			ports = new EObjectContainmentWithInverseEList<Port>(Port.class, this, AdlvPackage.APPLICATION__PORTS, AdlvPackage.PORT__APPLICATION);
		}
		return ports;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Module getModule() {
		if (eContainerFeatureID != AdlvPackage.APPLICATION__MODULE) return null;
		return (Module)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetModule(Module newModule, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newModule, AdlvPackage.APPLICATION__MODULE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setModule(Module newModule) {
		if (newModule != eInternalContainer() || (eContainerFeatureID != AdlvPackage.APPLICATION__MODULE && newModule != null)) {
			if (EcoreUtil.isAncestor(this, newModule))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newModule != null)
				msgs = ((InternalEObject)newModule).eInverseAdd(this, AdlvPackage.MODULE__APPLICATION, Module.class, msgs);
			msgs = basicSetModule(newModule, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.APPLICATION__MODULE, newModule, newModule));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ConfigurationStep> getInitialSteps() {
		if (initialSteps == null) {
			initialSteps = new EObjectContainmentWithInverseEList<ConfigurationStep>(ConfigurationStep.class, this, AdlvPackage.APPLICATION__INITIAL_STEPS, AdlvPackage.CONFIGURATION_STEP__APPLICATION);
		}
		return initialSteps;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Connection> getOutputConnection() {
		if (outputConnection == null) {
			outputConnection = new EObjectWithInverseResolvingEList<Connection>(Connection.class, this, AdlvPackage.APPLICATION__OUTPUT_CONNECTION, AdlvPackage.CONNECTION__FROM_APPLICATION);
		}
		return outputConnection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Connection> getInputConnection() {
		if (inputConnection == null) {
			inputConnection = new EObjectWithInverseResolvingEList<Connection>(Connection.class, this, AdlvPackage.APPLICATION__INPUT_CONNECTION, AdlvPackage.CONNECTION__TO_APPLICATION);
		}
		return inputConnection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Component> getComponents() {
		if (components == null) {
			components = new EObjectContainmentWithInverseEList<Component>(Component.class, this, AdlvPackage.APPLICATION__COMPONENTS, AdlvPackage.COMPONENT__APPLICATION);
		}
		return components;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<SafetyClause> getSafetyClause() {
		if (safetyClause == null) {
			safetyClause = new EObjectResolvingEList<SafetyClause>(SafetyClause.class, this, AdlvPackage.APPLICATION__SAFETY_CLAUSE);
		}
		return safetyClause;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ConfigurationStep> getStaticConfiguration() {
		if (staticConfiguration == null) {
			staticConfiguration = new EObjectContainmentEList<ConfigurationStep>(ConfigurationStep.class, this, AdlvPackage.APPLICATION__STATIC_CONFIGURATION);
		}
		return staticConfiguration;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.APPLICATION__PORTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getPorts()).basicAdd(otherEnd, msgs);
			case AdlvPackage.APPLICATION__MODULE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetModule((Module)otherEnd, msgs);
			case AdlvPackage.APPLICATION__INITIAL_STEPS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInitialSteps()).basicAdd(otherEnd, msgs);
			case AdlvPackage.APPLICATION__OUTPUT_CONNECTION:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getOutputConnection()).basicAdd(otherEnd, msgs);
			case AdlvPackage.APPLICATION__INPUT_CONNECTION:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInputConnection()).basicAdd(otherEnd, msgs);
			case AdlvPackage.APPLICATION__COMPONENTS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getComponents()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.APPLICATION__PORTS:
				return ((InternalEList<?>)getPorts()).basicRemove(otherEnd, msgs);
			case AdlvPackage.APPLICATION__MODULE:
				return basicSetModule(null, msgs);
			case AdlvPackage.APPLICATION__INITIAL_STEPS:
				return ((InternalEList<?>)getInitialSteps()).basicRemove(otherEnd, msgs);
			case AdlvPackage.APPLICATION__OUTPUT_CONNECTION:
				return ((InternalEList<?>)getOutputConnection()).basicRemove(otherEnd, msgs);
			case AdlvPackage.APPLICATION__INPUT_CONNECTION:
				return ((InternalEList<?>)getInputConnection()).basicRemove(otherEnd, msgs);
			case AdlvPackage.APPLICATION__COMPONENTS:
				return ((InternalEList<?>)getComponents()).basicRemove(otherEnd, msgs);
			case AdlvPackage.APPLICATION__STATIC_CONFIGURATION:
				return ((InternalEList<?>)getStaticConfiguration()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case AdlvPackage.APPLICATION__MODULE:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.MODULE__APPLICATION, Module.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdlvPackage.APPLICATION__NAME:
				return getName();
			case AdlvPackage.APPLICATION__PORTS:
				return getPorts();
			case AdlvPackage.APPLICATION__MODULE:
				return getModule();
			case AdlvPackage.APPLICATION__INITIAL_STEPS:
				return getInitialSteps();
			case AdlvPackage.APPLICATION__OUTPUT_CONNECTION:
				return getOutputConnection();
			case AdlvPackage.APPLICATION__INPUT_CONNECTION:
				return getInputConnection();
			case AdlvPackage.APPLICATION__COMPONENTS:
				return getComponents();
			case AdlvPackage.APPLICATION__SAFETY_CLAUSE:
				return getSafetyClause();
			case AdlvPackage.APPLICATION__STATIC_CONFIGURATION:
				return getStaticConfiguration();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdlvPackage.APPLICATION__NAME:
				setName((String)newValue);
				return;
			case AdlvPackage.APPLICATION__PORTS:
				getPorts().clear();
				getPorts().addAll((Collection<? extends Port>)newValue);
				return;
			case AdlvPackage.APPLICATION__MODULE:
				setModule((Module)newValue);
				return;
			case AdlvPackage.APPLICATION__INITIAL_STEPS:
				getInitialSteps().clear();
				getInitialSteps().addAll((Collection<? extends ConfigurationStep>)newValue);
				return;
			case AdlvPackage.APPLICATION__OUTPUT_CONNECTION:
				getOutputConnection().clear();
				getOutputConnection().addAll((Collection<? extends Connection>)newValue);
				return;
			case AdlvPackage.APPLICATION__INPUT_CONNECTION:
				getInputConnection().clear();
				getInputConnection().addAll((Collection<? extends Connection>)newValue);
				return;
			case AdlvPackage.APPLICATION__COMPONENTS:
				getComponents().clear();
				getComponents().addAll((Collection<? extends Component>)newValue);
				return;
			case AdlvPackage.APPLICATION__SAFETY_CLAUSE:
				getSafetyClause().clear();
				getSafetyClause().addAll((Collection<? extends SafetyClause>)newValue);
				return;
			case AdlvPackage.APPLICATION__STATIC_CONFIGURATION:
				getStaticConfiguration().clear();
				getStaticConfiguration().addAll((Collection<? extends ConfigurationStep>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdlvPackage.APPLICATION__NAME:
				setName(NAME_EDEFAULT);
				return;
			case AdlvPackage.APPLICATION__PORTS:
				getPorts().clear();
				return;
			case AdlvPackage.APPLICATION__MODULE:
				setModule((Module)null);
				return;
			case AdlvPackage.APPLICATION__INITIAL_STEPS:
				getInitialSteps().clear();
				return;
			case AdlvPackage.APPLICATION__OUTPUT_CONNECTION:
				getOutputConnection().clear();
				return;
			case AdlvPackage.APPLICATION__INPUT_CONNECTION:
				getInputConnection().clear();
				return;
			case AdlvPackage.APPLICATION__COMPONENTS:
				getComponents().clear();
				return;
			case AdlvPackage.APPLICATION__SAFETY_CLAUSE:
				getSafetyClause().clear();
				return;
			case AdlvPackage.APPLICATION__STATIC_CONFIGURATION:
				getStaticConfiguration().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdlvPackage.APPLICATION__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case AdlvPackage.APPLICATION__PORTS:
				return ports != null && !ports.isEmpty();
			case AdlvPackage.APPLICATION__MODULE:
				return getModule() != null;
			case AdlvPackage.APPLICATION__INITIAL_STEPS:
				return initialSteps != null && !initialSteps.isEmpty();
			case AdlvPackage.APPLICATION__OUTPUT_CONNECTION:
				return outputConnection != null && !outputConnection.isEmpty();
			case AdlvPackage.APPLICATION__INPUT_CONNECTION:
				return inputConnection != null && !inputConnection.isEmpty();
			case AdlvPackage.APPLICATION__COMPONENTS:
				return components != null && !components.isEmpty();
			case AdlvPackage.APPLICATION__SAFETY_CLAUSE:
				return safetyClause != null && !safetyClause.isEmpty();
			case AdlvPackage.APPLICATION__STATIC_CONFIGURATION:
				return staticConfiguration != null && !staticConfiguration.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //ApplicationImpl
