/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.AdlvPackage;
import fr.supelec.adlv.Application;
import fr.supelec.adlv.Component;
import fr.supelec.adlv.ComponentConfigurationStep;
import fr.supelec.adlv.ComponentType;
import fr.supelec.adlv.Connection;
import fr.supelec.adlv.PortExpression;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Component</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.adlv.impl.ComponentImpl#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ComponentImpl#getComponentConfigurationStep <em>Component Configuration Step</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ComponentImpl#getInputConnection <em>Input Connection</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ComponentImpl#getOutputConnection <em>Output Connection</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ComponentImpl#getApplication <em>Application</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ComponentImpl#getConsumerPortExpression <em>Consumer Port Expression</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ComponentImpl#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ComponentImpl extends EObjectImpl implements Component {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The cached value of the '{@link #getComponentConfigurationStep() <em>Component Configuration Step</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponentConfigurationStep()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentConfigurationStep> componentConfigurationStep;

	/**
	 * The cached value of the '{@link #getInputConnection() <em>Input Connection</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInputConnection()
	 * @generated
	 * @ordered
	 */
	protected EList<Connection> inputConnection;

	/**
	 * The cached value of the '{@link #getOutputConnection() <em>Output Connection</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutputConnection()
	 * @generated
	 * @ordered
	 */
	protected EList<Connection> outputConnection;

	/**
	 * The cached value of the '{@link #getConsumerPortExpression() <em>Consumer Port Expression</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConsumerPortExpression()
	 * @generated
	 * @ordered
	 */
	protected EList<PortExpression> consumerPortExpression;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected ComponentType type;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComponentImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdlvPackage.Literals.COMPONENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.COMPONENT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ComponentConfigurationStep> getComponentConfigurationStep() {
		if (componentConfigurationStep == null) {
			componentConfigurationStep = new EObjectWithInverseResolvingEList<ComponentConfigurationStep>(ComponentConfigurationStep.class, this, AdlvPackage.COMPONENT__COMPONENT_CONFIGURATION_STEP, AdlvPackage.COMPONENT_CONFIGURATION_STEP__COMPONENT);
		}
		return componentConfigurationStep;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Connection> getInputConnection() {
		if (inputConnection == null) {
			inputConnection = new EObjectWithInverseResolvingEList<Connection>(Connection.class, this, AdlvPackage.COMPONENT__INPUT_CONNECTION, AdlvPackage.CONNECTION__TO_COMPONENT);
		}
		return inputConnection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Connection> getOutputConnection() {
		if (outputConnection == null) {
			outputConnection = new EObjectWithInverseResolvingEList<Connection>(Connection.class, this, AdlvPackage.COMPONENT__OUTPUT_CONNECTION, AdlvPackage.CONNECTION__FROM_COMPONENT);
		}
		return outputConnection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Application getApplication() {
		if (eContainerFeatureID != AdlvPackage.COMPONENT__APPLICATION) return null;
		return (Application)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetApplication(Application newApplication, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newApplication, AdlvPackage.COMPONENT__APPLICATION, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setApplication(Application newApplication) {
		if (newApplication != eInternalContainer() || (eContainerFeatureID != AdlvPackage.COMPONENT__APPLICATION && newApplication != null)) {
			if (EcoreUtil.isAncestor(this, newApplication))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newApplication != null)
				msgs = ((InternalEObject)newApplication).eInverseAdd(this, AdlvPackage.APPLICATION__COMPONENTS, Application.class, msgs);
			msgs = basicSetApplication(newApplication, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.COMPONENT__APPLICATION, newApplication, newApplication));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PortExpression> getConsumerPortExpression() {
		if (consumerPortExpression == null) {
			consumerPortExpression = new EObjectWithInverseResolvingEList<PortExpression>(PortExpression.class, this, AdlvPackage.COMPONENT__CONSUMER_PORT_EXPRESSION, AdlvPackage.PORT_EXPRESSION__COMPONENT);
		}
		return consumerPortExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentType getType() {
		if (type != null && type.eIsProxy()) {
			InternalEObject oldType = (InternalEObject)type;
			type = (ComponentType)eResolveProxy(oldType);
			if (type != oldType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdlvPackage.COMPONENT__TYPE, oldType, type));
			}
		}
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentType basicGetType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetType(ComponentType newType, NotificationChain msgs) {
		ComponentType oldType = type;
		type = newType;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, AdlvPackage.COMPONENT__TYPE, oldType, newType);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(ComponentType newType) {
		if (newType != type) {
			NotificationChain msgs = null;
			if (type != null)
				msgs = ((InternalEObject)type).eInverseRemove(this, AdlvPackage.COMPONENT_TYPE__COMPONENT, ComponentType.class, msgs);
			if (newType != null)
				msgs = ((InternalEObject)newType).eInverseAdd(this, AdlvPackage.COMPONENT_TYPE__COMPONENT, ComponentType.class, msgs);
			msgs = basicSetType(newType, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.COMPONENT__TYPE, newType, newType));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.COMPONENT__COMPONENT_CONFIGURATION_STEP:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getComponentConfigurationStep()).basicAdd(otherEnd, msgs);
			case AdlvPackage.COMPONENT__INPUT_CONNECTION:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInputConnection()).basicAdd(otherEnd, msgs);
			case AdlvPackage.COMPONENT__OUTPUT_CONNECTION:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getOutputConnection()).basicAdd(otherEnd, msgs);
			case AdlvPackage.COMPONENT__APPLICATION:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetApplication((Application)otherEnd, msgs);
			case AdlvPackage.COMPONENT__CONSUMER_PORT_EXPRESSION:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getConsumerPortExpression()).basicAdd(otherEnd, msgs);
			case AdlvPackage.COMPONENT__TYPE:
				if (type != null)
					msgs = ((InternalEObject)type).eInverseRemove(this, AdlvPackage.COMPONENT_TYPE__COMPONENT, ComponentType.class, msgs);
				return basicSetType((ComponentType)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.COMPONENT__COMPONENT_CONFIGURATION_STEP:
				return ((InternalEList<?>)getComponentConfigurationStep()).basicRemove(otherEnd, msgs);
			case AdlvPackage.COMPONENT__INPUT_CONNECTION:
				return ((InternalEList<?>)getInputConnection()).basicRemove(otherEnd, msgs);
			case AdlvPackage.COMPONENT__OUTPUT_CONNECTION:
				return ((InternalEList<?>)getOutputConnection()).basicRemove(otherEnd, msgs);
			case AdlvPackage.COMPONENT__APPLICATION:
				return basicSetApplication(null, msgs);
			case AdlvPackage.COMPONENT__CONSUMER_PORT_EXPRESSION:
				return ((InternalEList<?>)getConsumerPortExpression()).basicRemove(otherEnd, msgs);
			case AdlvPackage.COMPONENT__TYPE:
				return basicSetType(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case AdlvPackage.COMPONENT__APPLICATION:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.APPLICATION__COMPONENTS, Application.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdlvPackage.COMPONENT__NAME:
				return getName();
			case AdlvPackage.COMPONENT__COMPONENT_CONFIGURATION_STEP:
				return getComponentConfigurationStep();
			case AdlvPackage.COMPONENT__INPUT_CONNECTION:
				return getInputConnection();
			case AdlvPackage.COMPONENT__OUTPUT_CONNECTION:
				return getOutputConnection();
			case AdlvPackage.COMPONENT__APPLICATION:
				return getApplication();
			case AdlvPackage.COMPONENT__CONSUMER_PORT_EXPRESSION:
				return getConsumerPortExpression();
			case AdlvPackage.COMPONENT__TYPE:
				if (resolve) return getType();
				return basicGetType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdlvPackage.COMPONENT__NAME:
				setName((String)newValue);
				return;
			case AdlvPackage.COMPONENT__COMPONENT_CONFIGURATION_STEP:
				getComponentConfigurationStep().clear();
				getComponentConfigurationStep().addAll((Collection<? extends ComponentConfigurationStep>)newValue);
				return;
			case AdlvPackage.COMPONENT__INPUT_CONNECTION:
				getInputConnection().clear();
				getInputConnection().addAll((Collection<? extends Connection>)newValue);
				return;
			case AdlvPackage.COMPONENT__OUTPUT_CONNECTION:
				getOutputConnection().clear();
				getOutputConnection().addAll((Collection<? extends Connection>)newValue);
				return;
			case AdlvPackage.COMPONENT__APPLICATION:
				setApplication((Application)newValue);
				return;
			case AdlvPackage.COMPONENT__CONSUMER_PORT_EXPRESSION:
				getConsumerPortExpression().clear();
				getConsumerPortExpression().addAll((Collection<? extends PortExpression>)newValue);
				return;
			case AdlvPackage.COMPONENT__TYPE:
				setType((ComponentType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdlvPackage.COMPONENT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case AdlvPackage.COMPONENT__COMPONENT_CONFIGURATION_STEP:
				getComponentConfigurationStep().clear();
				return;
			case AdlvPackage.COMPONENT__INPUT_CONNECTION:
				getInputConnection().clear();
				return;
			case AdlvPackage.COMPONENT__OUTPUT_CONNECTION:
				getOutputConnection().clear();
				return;
			case AdlvPackage.COMPONENT__APPLICATION:
				setApplication((Application)null);
				return;
			case AdlvPackage.COMPONENT__CONSUMER_PORT_EXPRESSION:
				getConsumerPortExpression().clear();
				return;
			case AdlvPackage.COMPONENT__TYPE:
				setType((ComponentType)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdlvPackage.COMPONENT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case AdlvPackage.COMPONENT__COMPONENT_CONFIGURATION_STEP:
				return componentConfigurationStep != null && !componentConfigurationStep.isEmpty();
			case AdlvPackage.COMPONENT__INPUT_CONNECTION:
				return inputConnection != null && !inputConnection.isEmpty();
			case AdlvPackage.COMPONENT__OUTPUT_CONNECTION:
				return outputConnection != null && !outputConnection.isEmpty();
			case AdlvPackage.COMPONENT__APPLICATION:
				return getApplication() != null;
			case AdlvPackage.COMPONENT__CONSUMER_PORT_EXPRESSION:
				return consumerPortExpression != null && !consumerPortExpression.isEmpty();
			case AdlvPackage.COMPONENT__TYPE:
				return type != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //ComponentImpl
