/**
 *  Copyright (c) 2007 Supelec.
 *  All rights reserved. This program and the accompanying materials
 *  are made available under the terms of the Eclipse Public License v1.0
 *  which accompanies this distribution, and is available at
 *  http://www.eclipse.org/legal/epl-v10.html
 * 
 *  This file is part of the ADLV tool
 *  Version 1.0 (December 5, 2007)
 * 
 *  Contributors:
 *      Computer Science Department, Supelec : initial implementation
 *  Contacts:
 *      Dominique.Marcadet@supelec.fr
 *      Frederic.Boulanger@supelec.fr
 *      Christophe.Jacquet@supelec.fr
 * 
 *
 * $Id$
 */
package fr.supelec.adlv.impl;

import fr.supelec.adlv.AdlvPackage;
import fr.supelec.adlv.BinaryExpression;
import fr.supelec.adlv.Expression;
import fr.supelec.adlv.ProducerPort;
import fr.supelec.adlv.UnaryExpression;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Expression</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.adlv.impl.ExpressionImpl#getProducerPort <em>Producer Port</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ExpressionImpl#getUnaryExpression <em>Unary Expression</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ExpressionImpl#getCompareRight <em>Compare Right</em>}</li>
 *   <li>{@link fr.supelec.adlv.impl.ExpressionImpl#getCompareLeft <em>Compare Left</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ExpressionImpl extends EObjectImpl implements Expression {
	/**
	 * The cached value of the '{@link #getProducerPort() <em>Producer Port</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProducerPort()
	 * @generated
	 * @ordered
	 */
	protected EList<ProducerPort> producerPort;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExpressionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return AdlvPackage.Literals.EXPRESSION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ProducerPort> getProducerPort() {
		if (producerPort == null) {
			producerPort = new EObjectWithInverseResolvingEList<ProducerPort>(ProducerPort.class, this, AdlvPackage.EXPRESSION__PRODUCER_PORT, AdlvPackage.PRODUCER_PORT__EVENT_EMIT_EXPRESSION);
		}
		return producerPort;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnaryExpression getUnaryExpression() {
		if (eContainerFeatureID != AdlvPackage.EXPRESSION__UNARY_EXPRESSION) return null;
		return (UnaryExpression)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetUnaryExpression(UnaryExpression newUnaryExpression, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newUnaryExpression, AdlvPackage.EXPRESSION__UNARY_EXPRESSION, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnaryExpression(UnaryExpression newUnaryExpression) {
		if (newUnaryExpression != eInternalContainer() || (eContainerFeatureID != AdlvPackage.EXPRESSION__UNARY_EXPRESSION && newUnaryExpression != null)) {
			if (EcoreUtil.isAncestor(this, newUnaryExpression))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newUnaryExpression != null)
				msgs = ((InternalEObject)newUnaryExpression).eInverseAdd(this, AdlvPackage.UNARY_EXPRESSION__EXPRESSION, UnaryExpression.class, msgs);
			msgs = basicSetUnaryExpression(newUnaryExpression, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.EXPRESSION__UNARY_EXPRESSION, newUnaryExpression, newUnaryExpression));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BinaryExpression getCompareRight() {
		if (eContainerFeatureID != AdlvPackage.EXPRESSION__COMPARE_RIGHT) return null;
		return (BinaryExpression)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCompareRight(BinaryExpression newCompareRight, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newCompareRight, AdlvPackage.EXPRESSION__COMPARE_RIGHT, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCompareRight(BinaryExpression newCompareRight) {
		if (newCompareRight != eInternalContainer() || (eContainerFeatureID != AdlvPackage.EXPRESSION__COMPARE_RIGHT && newCompareRight != null)) {
			if (EcoreUtil.isAncestor(this, newCompareRight))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newCompareRight != null)
				msgs = ((InternalEObject)newCompareRight).eInverseAdd(this, AdlvPackage.BINARY_EXPRESSION__RIGHT_EXPRESSION, BinaryExpression.class, msgs);
			msgs = basicSetCompareRight(newCompareRight, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.EXPRESSION__COMPARE_RIGHT, newCompareRight, newCompareRight));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BinaryExpression getCompareLeft() {
		if (eContainerFeatureID != AdlvPackage.EXPRESSION__COMPARE_LEFT) return null;
		return (BinaryExpression)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCompareLeft(BinaryExpression newCompareLeft, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newCompareLeft, AdlvPackage.EXPRESSION__COMPARE_LEFT, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCompareLeft(BinaryExpression newCompareLeft) {
		if (newCompareLeft != eInternalContainer() || (eContainerFeatureID != AdlvPackage.EXPRESSION__COMPARE_LEFT && newCompareLeft != null)) {
			if (EcoreUtil.isAncestor(this, newCompareLeft))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newCompareLeft != null)
				msgs = ((InternalEObject)newCompareLeft).eInverseAdd(this, AdlvPackage.BINARY_EXPRESSION__LEFT_EXPRESSION, BinaryExpression.class, msgs);
			msgs = basicSetCompareLeft(newCompareLeft, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdlvPackage.EXPRESSION__COMPARE_LEFT, newCompareLeft, newCompareLeft));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.EXPRESSION__PRODUCER_PORT:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getProducerPort()).basicAdd(otherEnd, msgs);
			case AdlvPackage.EXPRESSION__UNARY_EXPRESSION:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetUnaryExpression((UnaryExpression)otherEnd, msgs);
			case AdlvPackage.EXPRESSION__COMPARE_RIGHT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetCompareRight((BinaryExpression)otherEnd, msgs);
			case AdlvPackage.EXPRESSION__COMPARE_LEFT:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetCompareLeft((BinaryExpression)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case AdlvPackage.EXPRESSION__PRODUCER_PORT:
				return ((InternalEList<?>)getProducerPort()).basicRemove(otherEnd, msgs);
			case AdlvPackage.EXPRESSION__UNARY_EXPRESSION:
				return basicSetUnaryExpression(null, msgs);
			case AdlvPackage.EXPRESSION__COMPARE_RIGHT:
				return basicSetCompareRight(null, msgs);
			case AdlvPackage.EXPRESSION__COMPARE_LEFT:
				return basicSetCompareLeft(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID) {
			case AdlvPackage.EXPRESSION__UNARY_EXPRESSION:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.UNARY_EXPRESSION__EXPRESSION, UnaryExpression.class, msgs);
			case AdlvPackage.EXPRESSION__COMPARE_RIGHT:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.BINARY_EXPRESSION__RIGHT_EXPRESSION, BinaryExpression.class, msgs);
			case AdlvPackage.EXPRESSION__COMPARE_LEFT:
				return eInternalContainer().eInverseRemove(this, AdlvPackage.BINARY_EXPRESSION__LEFT_EXPRESSION, BinaryExpression.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdlvPackage.EXPRESSION__PRODUCER_PORT:
				return getProducerPort();
			case AdlvPackage.EXPRESSION__UNARY_EXPRESSION:
				return getUnaryExpression();
			case AdlvPackage.EXPRESSION__COMPARE_RIGHT:
				return getCompareRight();
			case AdlvPackage.EXPRESSION__COMPARE_LEFT:
				return getCompareLeft();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdlvPackage.EXPRESSION__PRODUCER_PORT:
				getProducerPort().clear();
				getProducerPort().addAll((Collection<? extends ProducerPort>)newValue);
				return;
			case AdlvPackage.EXPRESSION__UNARY_EXPRESSION:
				setUnaryExpression((UnaryExpression)newValue);
				return;
			case AdlvPackage.EXPRESSION__COMPARE_RIGHT:
				setCompareRight((BinaryExpression)newValue);
				return;
			case AdlvPackage.EXPRESSION__COMPARE_LEFT:
				setCompareLeft((BinaryExpression)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case AdlvPackage.EXPRESSION__PRODUCER_PORT:
				getProducerPort().clear();
				return;
			case AdlvPackage.EXPRESSION__UNARY_EXPRESSION:
				setUnaryExpression((UnaryExpression)null);
				return;
			case AdlvPackage.EXPRESSION__COMPARE_RIGHT:
				setCompareRight((BinaryExpression)null);
				return;
			case AdlvPackage.EXPRESSION__COMPARE_LEFT:
				setCompareLeft((BinaryExpression)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdlvPackage.EXPRESSION__PRODUCER_PORT:
				return producerPort != null && !producerPort.isEmpty();
			case AdlvPackage.EXPRESSION__UNARY_EXPRESSION:
				return getUnaryExpression() != null;
			case AdlvPackage.EXPRESSION__COMPARE_RIGHT:
				return getCompareRight() != null;
			case AdlvPackage.EXPRESSION__COMPARE_LEFT:
				return getCompareLeft() != null;
		}
		return super.eIsSet(featureID);
	}

} //ExpressionImpl
