/*******************************************************************************
 * Copyright (c) 2007 Supelec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This file is part of the ADLV tool
 * Version 1.0 (December 5, 2007)
 *
 * Contributors:
 *     Computer Science Department, Supelec : initial implementation
 * Contacts:
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *******************************************************************************/
package fr.supelec.adlv.generator;

import java.io.File;
import java.io.IOException;

import fr.supelec.adlv.*;

import fr.supelec.adlv.parser.EmfAdlvHelper;

public class EventTypeGenerator extends AdlvGenerator {

	EventTypeGenerator( EmfAdlvHelper helper ) {
		helper_ = helper;
	}
	
	void generate( String moduleName, String resultsPath ) throws IOException {
		String eventDirectory = resultsPath + "/" + EVENT_TYPE_DECLARATION_DIRECTORY;
		( new File( eventDirectory ) ).mkdir();
		
		openFile( eventDirectory, moduleName + EVENT_TYPE_FILE_SUFFIX, IDL3_EXTENSION );
		
		writeCppHeaderPrelude( moduleName );
		
		out_.write( "\n" );
		out_.write( "module " + moduleName + " {\n" );
		out_.write( "\n" );
		
		Module m = helper_.getModule(moduleName);
		for( Object o : m.getTokenTypes() ) {
			TokenType t = (TokenType) o;
			if( t instanceof EventType ) {
				out_.write( "    eventtype " + t.getName() + " {};\n" );
			}
		}
		
		out_.write( "\n" );
		out_.write( "};\n" );
		out_.write( "\n" );
		
		writeCppHeaderPostlude();
		
		closeFile();
	}
	
	private EmfAdlvHelper helper_;
}

